/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/DrawAxis.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _DrawAxis_h
#define _DrawAxis_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

#define DrawAxisLeft		0
#define DrawAxisRight		1
#define DrawAxisBottom		2
#define DrawAxisTop		3
#define DrawAxisAll		4

#define AXIS_NUM		DrawAxisAll

#define TIC_LONG		0
#define TIC_MEDIUM		1
#define TIC_SHORT		2
#define TIC_SPACE		3
#define TIC_LABEL		4
#define TIC_TIC			5
#define TIC_NUM			6

#define DrawAxisScaleGC		0
#define DrawAxisTextGC		1
#define DrawAxisGCNum		2

typedef struct _DrawAxisRec {
  Cal_t cal;
  double (*cal_l)();
  double (*cal_s)();
  char *(*unit)();
} DrawAxisRec, *DrawAxis_t;

#define DrawAxisCal(p)		((p)->cal)
#define DrawAxisCalL(p)		((p)->cal_l)
#define DrawAxisCalS(p)		((p)->cal_s)
#define DrawAxisUnit(p)		((p)->unit)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawAxis P_((GowDestination dest,
			    int x, int y, DrawAxis_t axis, int type,
			    GowScale scale, float *tic_dim, int fac,
			    int frame));
#undef P_

#endif				/* _DrawAxis_h */
