/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawDecomp.h,v 1.2 1994/05/26 19:48:54 vs Exp vs $ */

#ifndef _DrawDecomp_h
#define _DrawDecomp_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>
#include <Gow/DrawPeak.h>

typedef struct {
  Fit_t fit;
  DrawPeakRec peak;
} DrawDecompRec, *DrawDecomp_t;

#define DrawDecompPeak(p)	(&(p)->peak)
#define DrawDecompFit(p)	((p)->fit)

#define DrawDecompGCPos(p)	DrawPeakGCPos(DrawDecompPeak(p))
#define DrawDecompGCNeg(p)	DrawPeakGCNeg(DrawDecompPeak(p))
#define DrawDecompCal(p)	DrawPeakCal(DrawDecompPeak(p))
#define DrawDecompNorm(p)	DrawPeakNorm(DrawDecompPeak(p))

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawDecomp P_((GowDestination dest, DrawDecomp_t ddecomp,
			      GowScale x_scale, GowScale y_scale,
			      int step_width, int min_steps,
			      int calibrated,
			      GowScaleModificationType modification,
			      int normalized));
extern void DrawDecompExpand P_((DrawDecomp_t ddecomp,
				 GowScale x_scale, GowScaleType x_type,
				 int x_full,
				 GowScale y_scale, GowScaleType y_type,
				 int y_full,
				 int calibrated,
				 GowScaleModificationType modification,
				 int normalized));
#undef P_

#endif				/* _DrawDecomp_h */
