/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/DrawHMark.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _DrawHMark_h
#define _DrawHMark_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef struct {
  int gc_idx;
  PVec_t mrk;
  Val_t sgl;
  DVecRec vis;
} DrawHMrkRec, *DrawHMrk_t;

#define DrawHMrkGCIdx(p)	((p)->gc_idx)
#define DrawHMrkMrk(p)		((p)->mrk)
#define DrawHMrkSgl(p)		((p)->sgl)
#define DrawHMrkVis(p)		(&(p)->vis)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawHMark P_((GowDestination dest, DrawHMrk_t dmrk,
			     GowScale x_scale, GowScale y_scale,
			     double lft_frac, double rgt_frac,
			     double cross));
extern void DrawHMarkFree P_((DrawHMrk_t dmrk));
extern void DrawHMarkInit P_((DrawHMrk_t dmrk));
#undef P_

#endif				/* _DrawHMark_h */
