/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawPeak.h,v 1.2 1994/05/26 19:48:58 vs Exp vs $ */

#ifndef _DrawPeak_h
#define _DrawPeak_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef struct {
  int gc_pos;
  int gc_neg;
  Cal_t cal;
  double chn;
  void *par;
  double (*fct)();
  double *norm;
} DrawPeakRec, *DrawPeak_t;

#define DrawPeakGCPos(p)	((p)->gc_pos)
#define DrawPeakGCNeg(p)	((p)->gc_neg)
#define DrawPeakCal(p)		((p)->cal)
#define DrawPeakChn(p)		((p)->chn)
#define DrawPeakPar(p)		((p)->par)
#define DrawPeakFct(p)		((p)->fct)
#define DrawPeakNorm(p)		((p)->norm)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawPeak P_((GowDestination dest, DrawPeak_t dpeak,
			    GowScale x_scale, GowScale y_scale,
			    int step_width, int min_steps,
			    int calibrated,
			    GowScaleModificationType modification,
			    int normalized));
extern void DrawPeakExpand P_((DrawPeak_t dpeak,
			       GowScale x_scale, GowScaleType x_type,
			       int x_full,
			       GowScale y_scale, GowScaleType y_type,
			       int y_full,
			       int calibrated,
			       GowScaleModificationType modification,
			       int normalized));
#undef P_

#endif				/* _DrawPeak_h */
