/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawSpectrum.h,v 1.4 1994/12/02 21:22:04 vs Exp vs $ */

#ifndef _DrawSpectrum_h
#define _DrawSpectrum_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef enum {
  DrawMinMax,
  DrawFirstFound,
  DrawEach
} DrawCompressMode;

typedef struct {
  int gc_idx;
  Cal_t cal;
  Spc_t spc;
  double *norm;
  int line;
  char *name;
} DrawSpcRec, *DrawSpc_t;

#define DrawSpcGCIdx(p)		((p)->gc_idx)
#define DrawSpcSpc(p)		((p)->spc)
#define DrawSpcCal(p)		((p)->cal)
#define DrawSpcNorm(p)		((p)->norm)
#define DrawSpcLine(p)		((p)->line)
#define DrawSpcName(p)		((p)->name)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawSpectrum P_((GowDestination dest, DrawSpc_t dspc,
				GowScale x_scale, GowScale y_scale,
				int min_dx, int min_steps,
				DrawCompressMode compress,
				double line_space,
				int calibrated,
				GowScaleModificationType modification,
				int normalized));
extern void DrawSpectrumExpand P_((DrawSpc_t dspc,
				   GowScale x_scale, GowScaleType x_type,
				   int x_full,
				   GowScale y_scale, GowScaleType y_type,
				   int y_full,
				   int calibrated,
				   GowScaleModificationType modification,
				   int normalized));
#undef P_

#endif				/* _DrawSpectrum_h */
