/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowGCsX11.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowGCsX11_h
#define _GowGCsX11_h

#include <Gow/GowConfig.h>

/* Resources:

 Name			Class		RepType		Default Value
 ----			-----		-------		-------------
 font<idx>		Font		XFontStruct *	XtDefaultFont
 foreground<idx>	Foreground	Pixel		XtDefaultForeground
 background<idx>	Background	Pixel		XtDefaultBackground
 linestyle<idx>		Linestyle	GowLineStyle	GowLineSolid
 linewidth<idx>		Linewidth	Pixel		XtDefaultBackground

*/

typedef struct _GowGCsX11Rec *GowGCsX11;

typedef enum {
  GowLineSolid= 0,		/* pattern: ---------------------- */

  GowLineLongdashed= 1,		/* pattern: -------____-------____ */

  GowLineDisconnected= 2,	/* pattern: -______-______-______- */

  GowLineDotdashed= 3,		/* pattern: -----__-__-----__-__-- */

  GowLineDotted= 4,		/* pattern: -___-___-___-___-___-_ */

  GowLineShortdashed= 5,	/* pattern: ----____----____----__ */

  GowLineOdddashed= 6		/* pattern: --___-__---_--___-__-- */
} GowLineStyle;

#define GowEsolid		"solid"
#define GowElongdashed		"longdashed"
#define GowEdisconnected	"disconnected"
#define GowEdotdashed		"dotdashed"
#define GowEdotted		"dotted"
#define GowEshortdashed		"shortdashed"
#define GowEodddashed		"odddashed"

				/* resource names */
#define XtNlinestyle		"linestyle"
#ifndef XtNlinewidth
#	define XtNlinewidth	"linewidth"
#endif

				/* resource class names */
#define XtCLinestyle		"Linestyle"
#ifndef XtCLinewidth
#	define XtCLinewidth	"Linewidth"
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

/* GowGCsX11.c */
extern GowGCsX11 GowCreateGCsX11 P_((Widget w, int num));
extern void GowDestroyGCsX11 P_((Widget w, GowGCsX11 x11, int num));
extern void GowCvtStringToLineStyle P_((XrmValuePtr args, Cardinal *num_args,
					XrmValuePtr fromVal,
					XrmValuePtr toVal));
extern Boolean GowInitializeGCsX11 P_((int num));

#undef P_

#endif				/* _GowGCsX11_h */
