/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowGCsXfigP.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowGCsXfigP_h
#define _GowGCsXfigP_h

#include <Gow/GowGCsX11.h>
#include <Gow/GowGCsXfig.h>

typedef struct {
  GowLineStyle line_style;
  Dimension line_width;
  Dimension color;
  Dimension font;
  Dimension font_size;
  Dimension fill_style;
} XfigGCRec, *XfigGC;

  /* linestyle

   *-1 = Default
   * 0 = Solid
   * 1 = Dashed
   * 2 = Dotted
   */
#define XFIG_LINESTYLE		3

  /* color

   *-1 = Default
   * 0 = Black
   * 1 = Blue
   * 2 = Green
   * 3 = Cyan
   * 4 = Red
   * 5 = Magenta
   * 6 = Yellow
   * 7 = White
   * values from 8 to 2^30-1 = reserved for future use
   */
#define XFIG_COLOR		8

  /* fill style

   * 0 = not filled
   * 1 = white
   * ...  values from 2 to 20 are shades of grey, from lighter to darker
   * 21 = black
   */
#define XFIG_FILLSTYLE		22

#endif /* _GowGCsXfigP_h */
