/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowLabel.h,v 1.2 1994/05/26 19:49:23 vs Exp vs $ */

#ifndef _GowLabel_h
#define _GowLabel_h

#include <Gow/DrawLabel.h>
#include <Gow/GowObject.h>

/* additional GowLabel Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 labelDistance	     LabelDistance	float		1.0 units of charheight
 labelLine	     LabelLine		float		1.0 units of charheight
 topSpectrum	     TopSpectrum	Boolean		True
 channelRadius	     ChannelRadius	int		2
 libraryRadius	     LibraryRadius	float		1.0
*/
 
/* Class record constants */

extern WidgetClass gowLabelObjectClass;

typedef struct _GowObjectClassRec	*GowLabelObjectClass;
typedef struct _GowLabelObjectRec	*GowLabelObject;

typedef struct _GowLabelRec {
  Widget	gow;
  Widget	goo;
  DrawLblRec	lbl;
} GowLabelRec, *GowLabel;

#define XtNlabelDistance	"labelDistance"
#define XtNlabelLine		"labelLine"
#define XtNchannelRadius	"channelRadius"
#define XtNlibraryRadius	"libraryRadius"
#define XtNtopSpectrum		"topSpectrum"

#define XtCLabelDistance	"LabelDistance"
#define XtCLabelLine		"LabelLine"
#define XtCChannelRadius	"ChannelRadius"
#define XtCLibraryRadius	"LibraryRadius"
#define XtCTopSpectrum		"TopSpectrum"

#endif				/* _GowLabel_h */
