/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowVsWidget.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowVsWidget_h
#define _GowVsWidget_h

#include <X11/Shell.h>
#include <X11/Xmu/Converters.h>
#include <X11/Xfuncproto.h>

#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowWidget.h>

/****************************************************************
 *
 * GowVsWidget widget
 *
 ****************************************************************/

/* GowVsWidget Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 xScaleCalibrated    ScaleCalibrated	Boolean		False
 spectraNormalized   SpectraNormalized	Boolean		False
 yScaleModification  ScaleModifiation	GowScaleModificationType none

*/

typedef struct _GowWidgetClassRec	*GowVsWidgetClass;
typedef struct _GowVsWidgetRec		*GowVsWidget;

extern WidgetClass gowVsWidgetClass;

#define XtNxScaleCalibrated		"xScaleCalibrated"
#define XtNspectraNormalized		"spectraNormalized"
#define XtNyScaleModification		"yScaleModification"

#define XtCScaleCalibrated	"ScaleCalibrated"
#define XtCSpectraNormalized	"SpectraNormalized"
#define XtCScaleModification	"ScaleModification"

#define GowEefficiency		"efficiency"
#define GowEmultiplied		"multiplied"
#ifndef GowEnone
#	define GowEnone		"none"
#endif

/************************************************************
 *
 * Public Functions.
 *
 ************************************************************/

_XFUNCPROTOBEGIN

_XFUNCPROTOEND

#endif /* _GowVsWidget_h */
