/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsArg.c,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#define _vsArg_c

#include "vsTypes.h"
#include "vsArg.h"

/* ---------------------------------------------------------------------- */
int ArgRmArg(argc, argv, idx)
     int *argc;
     char **argv;
     int idx;
{
  int i;
  argv[*argc-1]= NULL;
  for (i= idx+1; i< *argc; i++) { argv[i-1]= argv[i]; }
  (*argc)--;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int ArgRmOption(argc, argv, option)
     int *argc;
     char **argv;
     char *option;
{
  int i;
  int idx= 0;
  for (i= *argc-1; i> 0; i--) {
    if (!strcmp(argv[i], option)) {
      if (!idx) { idx= i; }
      ArgRmArg(argc, argv, i); } }
  return idx;
}
/* ---------------------------------------------------------------------- */
int ArgRmOptionInt(argc, argv, option, number)
     int *argc;
     char **argv;
     char *option;
     int *number;
{
  int i;
  int idx= 0;
  for (i= *argc-1; i> 0; i--) {
    if (!strcmp(argv[i], option)) {
      if (i+1 == *argc) { return -1; }
      else if (!idx) {		/* accept only last value of option */
	idx= i;
	if (sscanf(argv[i+1], "%d", number) != 1) { return -1; } }
      ArgRmArg(argc, argv, i+1);
      ArgRmArg(argc, argv, i); } }
  return idx;
}
/* ---------------------------------------------------------------------- */
int ArgRmOptionString(argc, argv, option, string)
     int *argc;
     char **argv;
     char *option;
     char **string;
{
  int i;
  int idx= 0;
  for (i= *argc-1; i> 0; i--) {
    if (!strcmp(argv[i], option)) {
      if (i+1 == *argc) { return -1; }
      else if (!idx) {	/* accept only last value of option */
	idx= i; *string= argv[i+1]; }
      ArgRmArg(argc, argv, i+1);
      ArgRmArg(argc, argv, i); } }
  return idx;
}
