/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsConfig.c,v 1.3 1994/09/20 14:47:41 vs Exp vs $ */

#include <string.h>
#include "vsConfig.h"

#ifndef HAS_MEMMOVE
/* --------------------------------------------------------- */
/* memmove() copies memoryregions with respect to overlap */
void *memmove(t, f, len)
     void *t;
     void *f;
     size_t len;
{
  register int i;
  register char *tc= (char *)t;
  register char *fc= (char *)f;
  if (tc >= fc) { for (i= len-1; i >= 0; i--) { tc[i] = fc[i]; } }
  else { for (i= 0; i < len; i++) { tc[i] = fc[i]; } }
  return t;
}
#endif				/* HAS_MEMMOVE */

#ifndef HAS_STRCHR
char *strchr (s, c)
     char *s;
     char c;
{
  while (*s) {
    if (*s == c) { return (s); }
    else { s++; } }
  if (*s == c) { return (s); }
  return (NULL);
}
#endif				/* HAS_STRCHR */

#ifndef HAS_STRERROR
char *strerror(e)
     int e;
{
  extern char *sys_errlist[];
  return sys_errlist[e];
}
#endif
