/* vsFit.c */
extern char *FitError P_((int err_no));
extern int FitReset P_((Fit_t fp));
extern int FitStatReset P_((FitStat_t *fp));
extern int FitIntReset P_((FitInt_t *fip));
extern int FitResetBg P_((Fit_t fp));
extern int FitResetPeakVolumes P_((Fit_t fp));
extern int FitDisablePar P_((Fit_t fp, int idx, int userTyp, int check_corr));
extern int FitEnablePar P_((Fit_t fp, int idx, int userTyp, int check_corr));
extern int FitResetPeaks P_((Fit_t fp));
extern int FitSuspendBg P_((Fit_t fp));
extern int FitSuspendPeaks P_((Fit_t fp));
extern int FitUseBg P_((Fit_t fp));
extern int FitUsePeaks P_((Fit_t fp));
extern int FitInit P_((Fit_t fp));
extern int FitFree P_((Fit_t fp));
extern int FitCopy P_((Fit_t t, Fit_t f));
extern int FitStatCopy P_((FitStat_t *t, FitStat_t *f));
extern int FitIntCopy P_((FitInt_t *t, FitInt_t *f));
extern int FitDelPeak P_((Fit_t fp, int idx));
extern int FitSetupBg P_((Fit_t fp));
extern int FitSetPeak P_((Fit_t fp, double x));
extern int FitPeakSort P_((Fit_t fp, int typ));
extern int FitMaxPeakIdx P_((Fit_t fp, int *idx));
extern int FitFunctionChange P_((Fit_t fp, int typ));
extern int FitBgFunctionSetup P_((Fit_t fp, Par_t pp));
extern int FitBgFunctionFinish P_((Fit_t fp));
extern double FitBgFunction P_((Fit_t fp, double x));
extern double FitDBg2Function P_((Fit_t fp, double x));
extern double FitTotalBgFunction P_((Fit_t fp, double x));
extern int FitFunctionSetup P_((Fit_t fp, Par_t pp));
extern int FitFunctionFinish P_((Fit_t fp));
extern FitOpt FitPeakFunctionSetup P_((FitOpt vp, Fit_t fp, Par_t pp, int peakIdx));
extern FitOpt FitPeakFunctionFinish P_((FitOpt op));
extern int FitDerivationSetup P_((Fit_t fp, Par_t pp));
extern int FitDerivationFinish P_((Fit_t fp));
extern FitOpt FitUnitPeakDerivationSetup P_((FitOpt vp, Fit_t fp, Par_t pp, int peakIdx));
extern FitOpt FitUnitPeakDerivationFinish P_((FitOpt op));
extern int FitDerivation P_((Fit_t fp, double x, double *grad));
extern int FitUnitPeakDerivation P_((FitOptCA op, double x, double x0, double *fct_val, double *grad_x0));
extern double FitFunction P_((Fit_t fp, double x));
extern double FitNormVolume P_((FitOpt op));
extern double FitStepFunction P_((Fit_t fp, double x));
extern double FitPeakFunction P_((FitOpt op, double x));
extern double FitUnitPeakFunction P_((FitOpt op, double x, double x0));
