/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsFitSetup.h,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */
#ifndef _vsFitSetup_h
#define _vsFitSetup_h

#include <tv/vsConfig.h>

				/* error codes for FSErrNo */
#define FSNOERR		0 /* "vsFitSetup: no error" */
#define FSPOINT		1 /* "vsFitSetup: illegal NULL-pointer" */
#define FSNOMARK	2 /* "vsFitSetup: no marker defined" */
#define FSSORTPK	3 /* "vsFitSetup: can not sort peak positions" */
#define FSNOPEAK	4 /* "vsFitSetup: no peaks found" */
#define FSPKSUM0	5 /* "vsFitSetup: sum of peaks == 0.0 -- no step" */
#define FSNOBG		6 /* "vsFitSetup: can not evaluate background" */
#define FS0AMPL		7 /* "vsFitSetup: no peak with non-zero amplitude" */
#define FSNOWIDTH	8 /* "vsFitSetup: can not determine width" */
#define FSNOSPC		9 /* "vsFitSetup: no spectrum defined -- only position init" */
#define FSPKTYP	       10 /* "vsFitSetup: illegal peak function typ", */

#define FSsetErrNo(n)		{ FSErrNo= n; }

#ifdef _vsFitSetup_c
int FSErrNo= FSNOERR;
#else
extern int FSErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsFitSetupF.h>

#undef P_

#endif				/* _vsFitSetup_h */
