/* $Header: /usr/files/home/Gamma/vs/tv/edit/tv/RCS/vsPattern.h,v 1.1 1993/09/17 14:55:08 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    vsPattern.h
 */
#ifndef _vsPattern_h
#define _vsPattern_h

#include <tv/vsConfig.h>
#include <tv/vsTypes.h>

typedef struct {
  char *patt;
  char *expr;
} Pat_t;

#define PatPatt(pp)		((pp)->patt)
#define PatExpr(pp)		((pp)->expr)

typedef struct {		/* vector of PatRec's */
  VecCorePart	core;
  Pat_t		*p;
} PatVecRec, *PatVec_t;

#define PatVecPatt(pp,i)		(PatPatt(VecP(pp)+i))
#define PatVecExpr(pp,i)		(PatExpr(VecP(pp)+i))

#define PATNOERR	0 /* vsPattern: no error */
#define PATPOINT	1 /* vsPattern: illegal NULL-pointer */
#define PATALLOC	2 /* vsPattern: could not allocate pattern record */
#define PATFOUND	3 /* vsPattern: could not find pattern */
#define PATNOPAT	4 /* "vsPattern: no pattern defined" */

#ifdef _vsPattern_c
int PatErrNo= PATNOERR;
#else
extern int PatErrNo;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include <tv/vsPatternF.h>

#undef P_

#endif				/* _vsPattern_h */
