/* vsSearch.c */
extern char *SeaError P_((int err_no));
extern SeaPeakList SeaPeakSearch P_((void *spec, void *err_spec, int spec_type, int res, int left, int right, double def_prob, double (*w_cal)(), Cal_t cal, int (*peak_func)()));
extern SeaPeakList SeaCreatePeakList P_((void));
extern SeaPeak SeaEnterPeak P_((SeaPeakList peak_list, double channel, double Vol, double dVol, double Prob, double Amp, double dAmp, double BG, double dBG, double Chi, double width));
extern SeaPeak SeaInsertPeak P_((SeaPeakList peak_list, void *spec, void *err_spec, int spec_type, int res, double channel, double min_prob, double (*w_cal)(), Cal_t cal));
extern SeaPeak SeaClosestPeak P_((SeaPeakList pl, double chan));
extern void SeaFreePeakList P_((SeaPeakList pl));
extern void SeaFreeClosestPeak P_((SeaPeakList pl, double chan));
extern double SeaBgFunction P_((SeaPeak sp, double x));
extern double SeaFunction P_((SeaPeak sp, double x));
extern double SeaPeakFunction P_((SeaPeak sp, double x));
