/* vsSpectra.c */
static int SpcBufRead P_((SpcBuf_t *sbp, SpcFile_t sfp, int level, int line));
static int SpcBufWrite P_((SpcBuf_t *sbp, SpcFile_t sfp, int level, int line));
static int SpcBufAlloc P_((SpcBuf_t *sbp, int siz));
static int SpcBufRealloc P_((SpcBuf_t *sbp, int siz));
static int SpcBufFree P_((SpcBuf_t *sbp));
static int SpcBufInit P_((SpcBuf_t *sbp, int typ));
static int SpcBufReset P_((SpcBuf_t *sbp));
static int SpcBufClear P_((SpcBuf_t *sbp));
static int SpcBufSet P_((SpcBuf_t *sbp, void *buf, int typ, int siz, int num));
static int SpcBufCopy P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufAbsCopy P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufAdd P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufAbsAdd P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufSub P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufMin P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufMax P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufAbsEqual P_((SpcBuf_t *t, SpcBuf_t *f));
static int SpcBufInteger P_((SpcBuf_t *sbp));
static int SpcReadOperate P_((Spc_t sp, char *file, char *format, int (*fct)(), int (*dFct)()));
static int SpcReadOperateLine P_((Spc_t sp, SpcFile_t sfp, int line, int (*fct)(), int (*dFct)()));
