/* vsUserFace.c */
static int UFAlias P_((UF_t *up));
static int UFUnalias P_((UF_t *up));
static int UFAliasDelete P_((CmdVec_t at, char *name));
static int UFAliasInsert P_((CmdVec_t at, char *name, char *alias, char *args));
static int UFAliasShow P_((UF_t *up, char *name));
static int UFArgCopy P_((UF_t *up, int bufIdx, char *arg, int argLen, char *buffer, int bufLen));
static int UFArgGet P_((UF_t *up, char **bp, char *arg, int argLen));
static int UFBufferNext P_((UF_t *up, int bufTyp, int filIdx));
static int UFBufferPrev P_((UF_t *up));
static Cmd_t *UFCmd P_((UF_t *up, Men_t *mp));
static int UFCmdTest P_((UF_t *up, char *buffer, CmdVec_t tp, Cmd_t **best, char **bestStop, int *bestLen));
static int UFFileCloseIntern P_((UF_t *up, FILE **file, char **filename));
static int UFFileOpenIntern P_((UF_t *up, char *name, char *mode, FILE **file, char **filename));
static int UFInit P_((UF_t *up));
static int UFInitHist P_((UF_t *up));
static Cmd_t *UFIntCmd P_((UF_t *up, Men_t *mp));
static int UFIntTest P_((UF_t *up, char *buffer, int unexpected, int *i, char **stp));
static int UFItemCopy P_((UF_t *up, char **bp, char *buffer, int bufLen));
static int UFItemGetP P_((UF_t *up, char **bp, char *buffer, int bufLen, int opening, int closing));
static int UFItemGetQ P_((UF_t *up, char **bp, char *buffer, int bufLen, int quote));
static int UFMenuNext P_((UF_t *up, Men_t *mp, int loopStart, char *prompt));
static int UFMenuPrev P_((UF_t *up));
static int UFOperate P_((Cmd_t *cp, UF_t *up));
static int UFQuestionArgs P_((UF_t *up, Cmd_t *cp));
static int UFQuestionMenu P_((UF_t *up));
static int UFQuestionSkip P_((UF_t *up));
static Cmd_t *UFRealCmd P_((UF_t *up, Men_t *mp));
static int UFRealTest P_((UF_t *up, char *buffer, int unexpected, double *r, double *p, char **stp));
static void InputLoop P_((UF_t *up));
static Cmd_t *UFSpecialCmd P_((Men_t *mp, int entry));
static int UFStringEmpty P_((UF_t *up, char *s));
static int UFTermPrint P_((UF_t *up, FILE *fp, int paged, char *line));
static int UFTermScan P_((UF_t *up, char *buffer, int bufLen));
static char *UFTermTextBreak P_((UF_t *up, char *text, int col));
static int UFUpdateBuffer P_((UF_t *up));
static int UFUpdateInput P_((UF_t *up));
static int UFUpdateVar P_((UF_t *up));
