/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VsFace.h,v 1.6 1994/12/21 17:13:52 vs Exp vs $ */
#ifndef _VsFace_h
#define _VsFace_h

				/* standard setup for commands */
#define OPFACE(p)		{ UFOFACEFCT, p, NULL, NULL }
#define OPFCT(p)		{ UFOFCT, p, NULL, NULL }
#define OPMENU(p)		{ UFOMENU, NULL, p, NULL }
#define OPSTRING(p)		{ UFOMENU, NULL, NULL, p }

#define CMDCOMMENT		UFECOMMENT, FALSE, 0, OPFCT(UFMenuLoopContinue)

#define CMDFACE(p)		UFECMD, FALSE, 0, OPFACE(p)
#define CMDFCT(p)		UFECMD, FALSE, 0, OPFCT(p)
#define CMDFCTU(p)		UFECMD, TRUE,  0, OPFCT(p)
#define CMDMEN(p)		UFECMD, FALSE, 0, OPMENU(p)
#define CMDMENU(p)		UFECMD, TRUE, 0, OPMENU(p)

#define DFLTFACE(p)		UFEDEFAULT, FALSE, 0, OPFACE(p)
#define DFLTFCT(p)		UFEDEFAULT, FALSE, 0, OPFCT(p)
#define DFLTFCTU(p)		UFEDEFAULT, TRUE,  0, OPFCT(p)
#define DFLTMENU(p)		UFEDEFAULT, FALSE, 0, OPMENU(p)

#define INTFACE(p)		UFEINT, FALSE, 0, OPFACE(p)
#define INTFCT(p)		UFEINT, FALSE, 0, OPFCT(p)

#define REALFACE(p)		UFEREAL, FALSE, 0, OPFACE(p)
#define REALFCT(p)		UFEREAL, FALSE, 0, OPFCT(p)

#define EQBFACE(p)		UFEENTRYQB, FALSE, 0, OPFACE(p)

#define LQBFACE(p)		UFELOOPQB, FALSE, 0, OPFACE(p)
#define LQBFCT(p)		UFELOOPQB, FALSE, 0, OPFCT(p)

#define STDFACE(p)		UFESTANDARD, FALSE, 0, OPFACE(p)

#define NoArg			NULL
#define Menu			NULL

#define UnArg			"argument description not defined"

static char faceCalc[]= "<dest-idx> { <src-idx> | all | shown | activ }";
static char faceIdxChnVal[]= "<idx> <channel> <value>";
static char faceCopy[]= "<src-idx> { <dest-idx> | all | shown | activ }";
static char faceCutIdx[]= "<cut-idx>";
static char faceCutName[]= "<cut-filename>";
static char faceCutPathIdx[]= "<directory-idx>";
static char faceEnter[]= "<channel1> <value1> <channel2> <value2>";
static char faceExponent[]="<exponent>";
static char faceExpr[]="<expression>";
static char faceFactorIdxList[]= "<factor> { <idx> | all | shown | activ }"; 
static char faceFile[]="<filename>";
static char faceFileIdxList[] = "<file> { <idx> | all | shown | activ }";
static char faceFileList[]="{ <filename> }";
static char faceFileMList[]
  = "<command-filename> { <filename> | + | ++ | - | -- | <line-idx> }";
static char faceFormat[]= "<format>";
static char faceFrameDistance[]= "<tic-tic> <label-label>";
static char faceFrameLength[]
  ="<short-tic> <medium-tic> <long-tic> <axis-label-distance>";
static char faceFrameWidth[]= "<left> <right> <bottom> <top>";
static char faceIdx[]= "<idx>";
static char faceIdxAct[]= "<idx> | [activ]";
static char faceIdxActRange[]= "[activ] | ((<idx> | activ) [<range>])";
static char faceIdxFileList[]
  ="<idx> { <filename> | <idx> | all | shown | activ }";
static char faceIdxList[]= "{ <idx> | all | shown | activ }";
static char faceIdxListAct[]= "{ <idx> | all | shown | [activ] }";
static char faceIdxMList[]
  = "<dest-idx> { <filename> | + | ++ | - | -- | <line-idx> }";
static char faceInput[]="<input-filename>";
static char faceKeyTitle[]="<keytable-title>";
static char faceKeyFile[]="<keytable-file> [<keytable-title>]";
static char faceKeyFileTitle[]="<keytable-file> <keytable-title>";
static char faceLabelTitle[]="<labellist-title>";
static char faceLabelTitleScale[]="<labellist-title> [cal.|uncal.]";
static char faceLabelFile[]="<labellist-file>";
static char faceLabelOFile[]="<labellist-file> [<labellist-title>]";
static char faceLabelFileTitle[]="<labellist-file> <labellist-title>";
static char faceLabelText[]
  ="(cursor | (<val> [cal.|uncal.])) [<color-idx> [<string>]]";
static char faceMList[]= "{ <ls-filename> | + | ++ | - | -- | <line-idx> }";
static char faceMrkList[]= "{ cursor | (<val> [cal.|uncal.]) }";
static char faceMrkRange[]
  ="cursor | (<val> [cal.|uncal.] [ <val> [cal.|uncal.] ])";
static char faceMrkRangeAll[]
  ="all | cursor | (<val> [cal.|uncal.] [ <val> [cal.|uncal.] ])";
static char faceMtxIdx[]= "<mtx-idx>";
static char faceNameResIdx[]= "<name> <resolution> <idx>";
static char faceOffsetIdxList[]= "<offset> { <idx> | all | shown | activ }"; 
static char faceOutput[]="<output-filename>";
static char faceParBg[]		= "background";
static char faceParBgFac[]	= "factor-background";
static char faceParBgExp[]	= "exponent-background";
static char faceParPosition[]	= "position";
static char faceParSh[]		= "sh";
static char faceParSw[]		= "sw";
static char faceParTl[]		= "tl";
static char faceParTr[]		= "tr";
static char faceParVolume[]	= "volume";
static char faceParWidth[]	= "width";
static char faceParIdx[]= "[<parameter><idx>]";
static char facePos[]= "cursor | (<value> [cal.|uncal.])";
static char faceRefIdxList[]
  = "<reference-idx> { <idx> | all | shown | activ }"; 
static char faceScale[]= "calibrated | default | uncalibrated";
/*static char faceScaleFit[]= "[calibrated | default | uncalibrated]";*/
static char faceWindow[]= "<window-name>";
static char faceWindowNum[]= "<window-name> <num>";
static char faceString[]= "<string>";
static char faceTokenIdxList[]
  = "(<file> | <wildcard>) { <idx> | [all] | shown | activ }";
static char faceValue[]= "<value>";
static char faceSubWindow[]= "<subwindow-title>";
static char faceWildcard[]= "<wildcard>";

				/* ============================ */
				/* default special menu entries */
				/* ============================ */
static Cmd_t defaultSpecial[]= {
  { UFEEOF,	FALSE, 0, OPFACE(UFMenuLoopExit),	"Exit",NoArg},
  { UFECANCEL,	FALSE, 0, OPFACE(UFMenuLoopExit),	"Exit",NoArg},
  { UFEENTER,	FALSE, 0, OPFCT(ErrClear),
      "MenuLoopEnterErrClear",NoArg},
  { EQBFACE(UFMenuLoopLoop),	"MenuLoopLoop",NoArg},
  { UFELOOPHEAD,FALSE, 0, OPFCT(ErrClear),
      "MenuLoopHeadErrClear",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { UFELOOPTAIL,FALSE, 0, OPFACE(UFMenuLoopExitQBreak), "ExitQBreak",NoArg},
  { UFEERROR,	FALSE, 0, OPFACE(UFReset),		"Reset",NoArg},
  { UFESTANDARD,FALSE, 0, OPFACE(UF_ResetIllegal),	"ResetIllegal",NoArg}
};


				/* ======= */
				/* indices */
				/* ======= */
static Cmd_t indexCmd[]= {
  { CMDFCT(Idx_SetActSpc),	"active",NoArg},
  { CMDFCT(Idx_SetAll),		"all",NoArg},
  { CMDFCT(Idx_SetManaged),	"shown",NoArg},
  { CMDFCT(Idx_SetVisible),	"visible",NoArg},
  { EQBFACE(UFMenuLoopContinue),"Continue",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { INTFACE(Idx_ReadInt),	"<index>",NoArg}
};

Men_t indexMen= {
  UFLLOOP,		/* read several indices/keywords */
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, indexCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t spcTokenLoopCmd[]= {
  { CMDFCT(Idx_SetActSpc),	"active",NoArg},
  { CMDFCT(Idx_SetAll),		"all",NoArg},
  { CMDFCT(Idx_SetManaged),	"shown",NoArg},
  { CMDFCT(Idx_SetVisible),	"visible",NoArg},
  { EQBFACE(UFMenuLoopContinue),"Continue",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { INTFACE(Idx_ReadInt),	"<index>",NoArg},
  { DFLTFCT(Spc_TokenExec),	"<filename>['<format>]",NoArg}
};

Men_t spcTokenLoopMen= {
  UFLLOOP,		/* read several indices/keywords */
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, spcTokenLoopCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* activate */
				/* ======== */
static Cmd_t activateSpectrumCmd[]= {
  { CMDFCT(Act_ReadActSpc),	"index",faceIdx},
  { CMDFCT(Act_Next),		"next",NoArg},
  { CMDFCT(Act_Previous),	"previous",NoArg},
#ifndef NO_VD_GRAPHIC
  { CMDFCT(VdShowAct),		"status",NoArg},
#else
  { CMDFCT(Act_ShowDefault),	"status",NoArg},
#endif
  { EQBFACE(UFMenuLoopContinue),"Continue",NoArg},
  { INTFACE(Act_ReadActSpc),	"<index>",NoArg}
};

Men_t activateSpectrumMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,activateSpectrumCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t actScaleCmd[]= {
  { CMDFCT(Act_ScaleCalibrated),	"calibrated",faceScale},
  { CMDFCT(Act_ScaleDefault),		"default",faceScale},
  { CMDFCT(Act_ScaleUncalibrated),	"uncalibrated",faceScale}
};

Men_t actScaleMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, actScaleCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t actExpandCmd[]= {
  { CMDFCT(Act_ExpandAuto),	"automatic"},
  { CMDFCT(Act_ExpandDefault),	"default"},
  { CMDFCT(Act_ExpandRequest),	"request"}
};

Men_t actExpandMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, actExpandCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ===== */
				/* marks */
				/* ===== */
static Cmd_t mrkUnitCmd[]= {
  { CMDFCT(Mrk_UnitUncalib),	"uncalibrated",NoArg},
  { CMDFCT(Mrk_UnitCalib),	"calibrated",NoArg },
  { DFLTFCT(UFMenuLoopContinue),"Continue",NoArg}
};

Men_t mrkUnitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkUnitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t mrkWorkDeleteCmd[]= {
  { CMDFCT(Mrk_WorkReset),	"all",NoArg},
  { CMDFCT(Mrk_WorkDelete),	"range",faceMrkRange},
  { DFLTFCT(Mrk_WorkDelete),	"range",faceMrkRange},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t mrkWorkDeleteMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWorkDeleteCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t mrkWorkEnterVCmd[]= {
  { CMDFCT(Mrk_CursorV),	"cursor",NoArg},
  { CMDFCT(Mrk_WorkReadV),	"value",faceValue},
  { CMDFCT(Mrk_WorkReadVOffset),"offset",faceValue},
  { REALFACE(Mrk_WorkReadV),	"value",faceValue}
};

Men_t mrkWorkEnterVMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWorkEnterVCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

Men_t mrkEnterSingleVMen= {
  UFLSINGLE,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWorkEnterVCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t mrkWorkEnterHCmd[]= {
  { CMDFCT(Mrk_CursorH),	"cursor",NoArg},
  { CMDFCT(Mrk_WorkReadH),	"value",NoArg},
  { REALFACE(Mrk_WorkReadH),	"value",NoArg}
};

Men_t mrkWorkEnterHMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWorkEnterHCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

Men_t mrkEnterSingleHMen= {
  UFLSINGLE,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWorkEnterHCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* mark fit */
static Cmd_t mrkFitFitCmd[]= {
  { CMDFCT(Mrk_DeleteFit),	"delete",NoArg}
};

Men_t mrkFitFitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitFitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark peak */
static Cmd_t mrkPeakCmd[]= {
  { CMDFCT(FP_DeletePeak),	"delete",faceMrkRangeAll},
  { CMDFCT(FP_InsertPeak),	"enter",faceMrkList}
};

Men_t mrkPeakMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkPeakCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark bg-region */
static Cmd_t mrkFitBgCmd[]= {
  { CMDFCT(Mrk_DeleteFitBg),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterFitBg),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListFitBg),	"list",NoArg},
  { CMDFCT(Mrk_ReadFitBg),	"read",faceInput},
  { CMDFCT(Mrk_RestoreFitBg),	"restore",NoArg},
  { CMDFCT(Mrk_StoreFitBg),	"store",NoArg},
  { CMDFCT(Mrk_WriteFitBg),	"write",faceOutput}
};

Men_t mrkFitBgMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitBgCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark region */
static Cmd_t mrkFitRegNumCmd[]= {
  { CMDFCT(Mrk_FitRegMultiple),	"multiple",NoArg},
  { CMDFCT(Mrk_FitRegSingle),	"single",NoArg}
};

Men_t mrkFitRegNumMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitRegNumCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t mrkFitRegCmd[]= {
  { CMDFCT(Mrk_DeleteFitReg),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterFitReg),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListFitReg),	"list",NoArg},
  { CMDFCT(Mrk_ReadFitReg),	"read",faceInput},
  { CMDFCT(Mrk_RestoreFitReg),	"restore",NoArg},
  { CMDMEN(&mrkFitRegNumMen),	"number",Menu},
  { CMDFCT(Mrk_StoreFitReg),	"store",NoArg},
  { CMDFCT(Mrk_WriteFitReg),	"write",faceOutput}
};

Men_t mrkFitRegMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitRegCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark bin */
static Cmd_t mrkFitBinCmd[]= {
  { CMDFCT(Mrk_DeleteFitBin),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterFitBin),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListFitBin),	"list",NoArg},
  { CMDFCT(Mrk_ReadFitBin),	"read",faceInput},
  { CMDFCT(Mrk_RestoreFitBin),	"restore",NoArg},
  { CMDFCT(Mrk_StoreFitBin),	"store",NoArg},
  { CMDFCT(Mrk_WriteFitBin),	"write",faceOutput}
};

Men_t mrkFitBinMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitBinCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit marker */
static Cmd_t mrkFitCmd[]= {
  { CMDMEN(&mrkFitBinMen),	"bin",Menu},
  { CMDMEN(&mrkFitBgMen),	"bg-region",Menu},
  { CMDMEN(&mrkFitFitMen),	"fit",Menu},
  { CMDMEN(&mrkPeakMen),	"peak",Menu},
  { CMDMEN(&mrkFitRegMen),	"region",Menu}
};

Men_t mrkFitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkFitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark psearch */
static Cmd_t mrkSeaCmd[]= {
  { CMDFCT(Mrk_DeleteFitSea),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterFitSea),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListFitSea),	"list",NoArg},
  { CMDFCT(Mrk_ReadFitSea),	"read",faceInput},
  { CMDFCT(Mrk_RestoreFitSea),	"restore",NoArg},
  { CMDFCT(Mrk_StoreFitSea),	"store",NoArg},
  { CMDFCT(Mrk_WriteFitSea),	"write",faceOutput}
};

Men_t mrkSeaMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkSeaCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark read */
static Cmd_t mrkNormCmd[]= {
  { CMDFCT(Mrk_DeleteNorm),	"delete",NoArg},
  { CMDFCT(Mrk_EnterNorm),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListNorm),	"list",NoArg},
  { CMDFCT(Mrk_ReadNorm),	"read",faceInput},
  { CMDFCT(Mrk_RestoreNorm),	"restore",NoArg},
  { CMDFCT(Mrk_StoreNorm),	"store",NoArg},
  { CMDFCT(Mrk_WriteNorm),	"write",faceOutput}
};

Men_t mrkNormMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkNormCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark read */
static Cmd_t mrkRclCmd[]= {
  { CMDFCT(Mrk_DeleteRcl),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterRcl),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListRcl),	"list",NoArg},
  { CMDFCT(Mrk_ReadRcl),	"read",faceInput},
  { CMDFCT(Mrk_RestoreRcl),	"restore",NoArg},
  { CMDFCT(Mrk_StoreRcl),	"store",NoArg},
  { CMDFCT(Mrk_WriteRcl),	"write",faceOutput}
};

Men_t mrkRclMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkRclCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark read */
static Cmd_t mrkCutCutCmd[]= {
  { CMDFCT(Mrk_DeleteCut),	"delete",NoArg},
  { CMDFCT(Mrk_EnterCut),	"enter",faceMrkList}
};

Men_t mrkCutCutMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkCutCutCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark read */
static Cmd_t mrkBgGatCmd[]= {
  { CMDFCT(Mrk_DeleteBgGate),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterBgGate),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListBgGate),	"list",NoArg},
  { CMDFCT(Mrk_ReadBgGate),	"read",faceInput},
  { CMDFCT(Mrk_RestoreBgGate),	"restore",NoArg},
  { CMDFCT(Mrk_StoreBgGate),	"store",NoArg},
  { CMDFCT(Mrk_WriteBgGate),	"write",faceOutput}
};

Men_t mrkBgGatMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkBgGatCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark gate */
static Cmd_t mrkGatCmd[]= {
  { CMDFCT(Mrk_DeleteGate),	"delete",faceMrkRangeAll},
  { CMDFCT(Mrk_EnterGate),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListGate),	"list",NoArg},
  { CMDFCT(Mrk_ReadGate),	"read",faceInput},
  { CMDFCT(Mrk_RestoreGate),	"restore",NoArg},
  { CMDFCT(Mrk_StoreGate),	"store",NoArg},
  { CMDFCT(Mrk_WriteGate),	"write",faceOutput}
};

Men_t mrkGatMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkGatCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* cut marker */
static Cmd_t mrkCutCmd[]= {
  { CMDMEN(&mrkBgGatMen),	"bg-gate",Menu},
  { CMDMEN(&mrkCutCutMen),	"cut",Menu},
  { CMDMEN(&mrkGatMen),		"gate",Menu}
};

Men_t mrkCutMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkCutCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark vertical */
static Cmd_t mrkVertCmd[]= {
  { CMDFCT(Mrk_DeleteVertical),		"delete",NoArg},
  { CMDFCT(Mrk_EnterVertical),		"enter",faceMrkList},
  { CMDFCT(Mrk_ListVertical),		"list",NoArg},
  { CMDFCT(Mrk_ReadVertical),		"read",faceInput},
  { CMDFCT(Mrk_RestoreVertical),	"restore",NoArg},
  { CMDFCT(Mrk_StoreVertical),		"store",NoArg},
  { CMDFCT(Mrk_WriteVertical),		"write",faceOutput}
};

Men_t mrkVertMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkVertCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* mark horizontal */
static Cmd_t mrkHoriCmd[]= {
  { CMDFCT(Mrk_DeleteHorizontal),	"delete",NoArg},
  { CMDFCT(Mrk_EnterHorizontal),	"enter",faceMrkList},
  { CMDFCT(Mrk_ListHorizontal),		"list",NoArg},
  { CMDFCT(Mrk_ReadHorizontal),		"read",faceInput},
  { CMDFCT(Mrk_RestoreHorizontal),	"restore",NoArg},
  { CMDFCT(Mrk_StoreHorizontal),	"store",NoArg},
  { CMDFCT(Mrk_WriteHorizontal),	"write",faceOutput}
};

Men_t mrkHoriMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkHoriCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* window marker */
static Cmd_t mrkWinCmd[]= {
  { CMDMEN(&mrkHoriMen),	"horizontal",Menu},
  { CMDMEN(&mrkVertMen),	"vertical",Menu}
};

Men_t mrkWinMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mrkWinCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* ============ */
				/* command-file */
				/* ============ */
static Cmd_t cmdFileCmd[]= {
  { CMDFACE(UFFileClose),	"close",NoArg},
  { CMDFACE(UF_FileOpenM),	"open","<command-file>"},
  { CMDFACE(UFFileResume),	"resume",NoArg},
  { CMDFACE(UFFileSuspend),	"suspend",NoArg}
};

Men_t cmdFileMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, cmdFileCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ===== */
				/* mfile */
				/* ===== */
static Cmd_t mFileLoopCmd[]= {
  { CMDFCT(Pth_MInc),		"+",NoArg},
  { CMDFCT(Pth_MIncLoop),	"++",NoArg},
  { CMDFCT(Pth_MDec),		"-",NoArg},
  { CMDFCT(Pth_MDecLoop),	"--",NoArg},
  { DFLTFCT(Pth_MOpen),		"<filename>",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { INTFCT(Pth_MSet),		"<line-idx>",NoArg}
};

Men_t mFileLoopMen= {
  UFLSINGLELOOP,
  faceMList,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, mFileLoopCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static char faceMIndex[]= "<line-idx>";
static char faceMInput[]= "<ls-filename>";

static Cmd_t mFileCmd[]= {
  { CMDFCT(Spc_MAdd),		"add",faceIdxMList},
  { CMDFCT(Pth_MClose),		"close",NoArg},
  { CMDFCT(Spc_MCommandGet),	"commandget",faceFileMList},
  { CMDFCT(Spc_MGet),		"get",faceMList},
  { CMDFCT(Pth_MList),		"list",faceMList},
  { CMDFCT(Pth_MOpen),		"open",faceMInput},
  { CMDFCT(Pth_MSet),		"position",faceMIndex},
  { CMDFCT(Spc_MSubtract),	"subtract",faceIdxMList}
};

Men_t mFileMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,mFileCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ============ */
				/* calibrations */
				/* ============ */
static Cmd_t calEfcCmd[]= {
  { CMDFCT(Cal_CopyEfc),	"copy",faceCopy},
  { CMDFCT(Cal_DeleteEfc),	"delete",faceIdxList},
  { CMDFCT(Cal_ListEfc),	"list",faceIdxList},
  { CMDFCT(Cal_ReadEfc),	"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteEfc),	"write",faceTokenIdxList},
  { DFLTFCT(Cal_ReadEfc),	"read",faceTokenIdxList}
};

Men_t calEfcMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calEfcCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calTlCmd[]= {
  { CMDFCT(Cal_CopyTl),		"copy",faceCopy},
  { CMDFCT(Cal_DeleteTl),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterTl),	"enter",faceEnter},
  { CMDFCT(Cal_ListTl),		"list",faceIdxList},
  { CMDFCT(Cal_ReadTl),		"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteTl),	"write",faceTokenIdxList},
  { DFLTFCT(Cal_ReadTl),	"read",faceTokenIdxList}
};

Men_t calTlMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calTlCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calPosCmd[]= {
  { CMDFCT(Cal_CopyP),		"copy",faceCopy},
  { CMDFCT(Cal_DeleteP),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterP),		"enter",faceEnter},
  { CMDFCT(Cal_ListP),		"list",faceIdxList},
  { CMDFCT(Cal_ReadP),		"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteP),		"write",faceTokenIdxList},
  { DFLTFCT(Cal_ReadP),		"read",faceTokenIdxList}
};

Men_t calPosMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calPosCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calTrCmd[]= {
  { CMDFCT(Cal_CopyTr),		"copy",faceCopy},
  { CMDFCT(Cal_DeleteTr),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterTr),	"enter",faceEnter},
  { CMDFCT(Cal_ListTr),		"list",faceIdxList},
  { CMDFCT(Cal_ReadTr),		"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteTr),	"write",faceTokenIdxList},
  { DFLTFCT(Cal_ReadTr),	"read",faceTokenIdxList}
};

Men_t calTrMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calTrCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calSetCmd[]= {
  { CMDFCT(Cal_CopySet),	"copy",faceCopy},
  { CMDFCT(Cal_DeleteSet),	"delete",faceIdxList},
  { CMDFCT(Cal_ListSet),	"list",faceIdxList},
  { CMDFCT(Cal_ReadSet),	"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteSet),	"write",faceTokenIdxList},
  { DFLTFCT(Cal_ReadSet),	"read",faceTokenIdxList}
};

Men_t calSetMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calSetCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calStartCmd[]= {
  { CMDFCT(Cal_CopyStart),	"copy",faceCopy},
  { CMDFCT(Cal_DeleteStart),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterStart),	"enter",faceValue}
};

Men_t calStartMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calStartCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calUnitCmd[]= {
  { CMDFCT(Cal_CopyUnit),	"copy",faceCopy},
  { CMDFCT(Cal_DeleteUnit),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterUnit),	"enter",faceString}
};

Men_t calUnitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calUnitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calWidthCmd[]= {
  { CMDFCT(Cal_CopyW),		"copy",faceCopy},
  { CMDFCT(Cal_DeleteW),	"delete",faceIdxList},
  { CMDFCT(Cal_EnterW),		"enter",faceEnter},
  { CMDFCT(Cal_ListW),		"list",faceIdxList},
  { CMDFCT(Cal_ReadW),		"read",faceTokenIdxList},
  { CMDFCT(Cal_WriteW),		"write",faceTokenIdxList}
};

Men_t calWidthMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calWidthCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t calCmd[]= {
  { CMDMEN(&calEfcMen),		"efficiency",Menu},
  { CMDMEN(&calTlMen),		"lefttail",Menu},
  { CMDMEN(&calPosMen),		"position",Menu},
  { CMDMEN(&calTrMen),		"righttail",Menu},
  { CMDMEN(&calSetMen),		"set",Menu},
  { CMDMEN(&calStartMen),	"startchannel",Menu},
  { CMDMEN(&calUnitMen),	"unit",Menu},
  { CMDMEN(&calWidthMen),	"width",Menu},
  { DFLTMENU(&calPosMen),	"position",Menu}
};

Men_t calMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, calCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* spectrum */
				/* ======== */
static Cmd_t spcFormatCmd[]= {
  { CMDFCT(Spc_FormatIn),	"input",faceFormat},
  { CMDFCT(Spc_FormatOut),	"output",faceFormat},
  { DFLTFCT(Spc_FormatIn),	"input",faceFormat}
};

Men_t spcFormatMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,spcFormatCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t spcShowCmd[]= {
  { CMDFCT(Act_ReadManaged),	"index",faceIdxList},
  { CMDFCT(Act_ManageNext),	"next",NoArg},
  { CMDFCT(Act_ManagePrevious),	"previous",NoArg},
  { CMDFCT(Act_ReadAdd),	"+",faceIdxList},
  { CMDFCT(Act_ReadSub),	"-",faceIdxList},
  { CMDFCT(DS_ManageNames),	"names",NoArg},
  { DFLTFCT(Act_ReadManaged),	"index",faceIdxList}
};

Men_t spcShowMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,spcShowCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* spectrum root */
static Cmd_t spcCmd[]= {
  { CMDMEN(&activateSpectrumMen),"activate",Menu},
  { CMDFCT(Spc_Add),		"add",faceIdxFileList},
  { CMDFCT(Spc_Host),		"analysator",faceString},
  { CMDFCT(Spc_Copy),		"copy",faceCopy},
  { CMDFCT(Spc_Create),		"create",faceNameResIdx},
  { CMDFCT(Spc_Delete),		"delete",faceIdxList},
  { CMDFCT(Spc_Enter),		"enter",faceIdxChnVal},
  { CMDMEN(&spcFormatMen),	"format",Menu},
  { CMDFCT(Spc_Get),		"get",faceFileList},
  { CMDMEN(&mFileMen),		"ls-file",Menu},
  { CMDFCT(Spc_Maximum),	"maximum",faceCalc},
  { CMDFCT(Spc_Minimum),	"minimum",faceCalc},
  { CMDFCT(Spc_Multiply),	"multiply",faceFactorIdxList},
  { CMDFCT(Spc_Norm),	        "norm",faceIdxList},
  { CMDFCT(Spc_Offset),		"offset",faceOffsetIdxList},
  { CMDFCT(Spc_Read),		"read",faceFileIdxList},
  { CMDFCT(Spc_Resolution),	"resolution","<idx> <resolution>"},
  { CMDFCT(Spc_Show),		"status",NoArg},
  { CMDFCT(Spc_Subtract),	"subtract",faceIdxFileList},
  { CMDFCT(Spc_Update),		"update",faceIdxList},
  { CMDFCT(Spc_Write),		"write",faceTokenIdxList},
  { DFLTFCT(Spc_Get),		"get",faceFileList}
};

Men_t spcMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,spcCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ============= */
				/* normalization */
				/* ============= */

static Cmd_t nrmTypCmd[]= {
  { CMDFCT(Nrm_TypFactor),	"factor",faceFactorIdxList},
  { CMDFCT(Nrm_TypMaximum),	"maximum",faceIdxList},
  { CMDFCT(Nrm_TypReference),	"reference",faceRefIdxList},
  { CMDFCT(Nrm_TypUnity),	"unity",faceIdxList}
};

Men_t nrmTypMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,nrmTypCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* normalization root */
static Cmd_t nrmCmd[]= {
  { CMDMEN(&mrkNormMen),	"marker",Menu},
  { CMDFCT(Nrm_TypOff),		"off",NoArg},
  { CMDFCT(Mrk_ScaleNorm),	"scale",faceScale},
  { CMDFCT(Nrm_Show),		"status",NoArg},
  { CMDMEN(&nrmTypMen),		"type",Menu},
  { DFLTMENU(&nrmTypMen),	"type",Menu}
};

Men_t nrmMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,nrmCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ============= */
				/* recalibration */
				/* ============= */

				/* recalibration typ */
static Cmd_t rclTypCmd[]= {
  { CMDFCT(Rcl_TypSetCoM),	"center-of-mass",NoArg},
  { CMDFCT(Rcl_TypSetSquare),	"squared-distance",NoArg},
  { CMDFCT(Rcl_TypSetPair),	"pair",NoArg},
  { CMDFCT(Rcl_TypSetPolynom),	"polynom",NoArg}
};

Men_t rclTypMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,rclTypCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* recalibration root */
static Cmd_t rclCmd[]= {
  { CMDFCT(Rcl_Append),		"append",faceTokenIdxList},
  { CMDFCT(Rcl_Create),		"create",faceRefIdxList},
  { CMDFCT(Rcl_Delete),		"delete",faceIdxList},
  { CMDMEN(&mrkRclMen),		"marker",Menu},
  { CMDFCT(Rcl_List),		"list",faceIdxList},
  { CMDFCT(Rcl_Read),		"read",faceTokenIdxList},
  { CMDMEN(&rclTypMen),		"type",Menu},
  { CMDFCT(Rcl_Write),		"write",faceTokenIdxList}
};

Men_t rclMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,rclCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ============= */
				/* fit parameter */
				/* ============= */

				/* parameter name/product in expression */
static Cmd_t parNameCmd[]= {
  { CMDFCT(FP_Product),			NULL,"<name>[<idx>]"},
  { EQBFACE(UFMenuLoopExit),		"Exit",NoArg},
  { DFLTFCT(UFMenuLoopContinue),	"Continue",NoArg}
};

Men_t parNameMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parNameCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* parameter product */
static Cmd_t parProductCmd[]= {
  { CMDFCTU(FP_Mul),			"*",faceExpr},
  { CMDFCTU(FP_Div),			"/",faceExpr},
  { EQBFACE(UFMenuLoopExit),		"Exit",NoArg},
  { DFLTFCT(UFMenuLoopContinue),	"Continue",NoArg}
};

Men_t parProductMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parProductCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* parameter sign */
static Cmd_t parSignCmd[]= {
  { CMDFCTU(FP_Add), 			"+",faceExpr},
  { CMDFCTU(FP_Sub),	 		"-",faceExpr},
  { EQBFACE(UFMenuLoopExit),		"Exit",NoArg},
  { DFLTFCT(UFMenuLoopContinue),	"Continue",NoArg}
};

Men_t parSignMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parSignCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* position parameter */
static char facePosExpr[]
  = "([=] <expr>) | (free <expr>) | (hold <expr>) | none | (spaced [position<idx>])";

static Cmd_t parPosCmd[]= {
  { CMDFCTU(FP_Set),		"=",faceExpr},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr},
  { CMDFCT(FP_None),		"none",NoArg},
  { CMDFCT(FP_Spaced), 		"spaced",faceParIdx},
  { DFLTFCTU(FP_Set),		"=",faceExpr}
};

Men_t parPosMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parPosCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* width parameter */
static char faceWidth[]
  = "([=] <expr>) | calibrated | (free <expr>) | (hold <expr>) | (equal [width<idx>])";

static Cmd_t parWidthCmd[]= {
  { CMDFCTU(FP_Set),		"=",faceExpr},
  { CMDFCT(FP_Calibrated), 	"calibrated",NoArg},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr},
  { CMDFCT(FP_Equal), 		"equal",faceParIdx},
  { DFLTFCTU(FP_Set),		"=",faceExpr}
};

Men_t parWidthMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parWidthCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* volume parameter */
static char faceVolume[] = "([=] <expr>) | (free <expr>) | (hold <expr>)";

static Cmd_t parVolumeCmd[]= {
  { CMDFCTU(FP_Set),		"=",faceExpr},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr},
  { DFLTFCTU(FP_Set),		"=",faceExpr}
};

Men_t parVolumeMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parVolumeCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* background parameter */
static char faceBg[] = "([=] <expr>) | (free <expr>) | (hold <expr>)";

static Cmd_t parBgCmd[]= {
  { CMDFCTU(FP_Set),		"=",faceExpr},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr},
  { DFLTFCTU(FP_Set),		"=",faceExpr}
};

Men_t parBgMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parBgCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* all background parameter */
static Cmd_t parBgAllCmd[]= {
  { CMDFCT(FP_BgGrad),		"degree",faceValue},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr}
};

Men_t parBgAllMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parBgAllCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t parBgExpAllCmd[]= {
  { CMDFCT(FP_BgExpNum),	"number",faceValue},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr}
};

Men_t parBgExpAllMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parBgExpAllCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* step/tail parameter */
static char faceStepTail[]
  = "(([=] <expr>) | calibrated | (free <expr>) | (hold <expr>) | (equal [<par>]) | none)";

static Cmd_t parStepTailCmd[]= {
  { CMDFCTU(FP_Set),		"=",faceExpr},
  { CMDFCT(FP_Calibrated), 	"calibrated",NoArg},
  { CMDFCT(FP_Free), 		"free",faceExpr},
  { CMDFCT(FP_Hold),		"hold",faceExpr},
  { CMDFCT(FP_Equal), 		"equal",faceParIdx},
  { CMDFCT(FP_None),		"none",NoArg},
  { DFLTFCTU(FP_Set),		"=",faceExpr}
};

Men_t parStepTailMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parStepTailCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* parameter root */
char *parBg		= faceParBg;
char *parBgFac		= faceParBgFac;
char *parBgExp		= faceParBgExp;
char *parPosition	= faceParPosition;
char *parSh		= faceParSh;
char *parSw		= faceParSw;
char *parTl		= faceParTl;
char *parTr		= faceParTr;
char *parVolume		= faceParVolume;
char *parWidth		= faceParWidth;

static Cmd_t parCmd[]= {
  { CMDFCTU(FP_Bg),		faceParBg,faceBg},
  { CMDFCTU(FP_BgExp),		faceParBgExp,faceBg},
  { CMDFCTU(FP_BgFac),		faceParBgFac,faceBg},
  { CMDFCTU(FP_Position),	faceParPosition,facePosExpr},
  { CMDFCTU(FP_Sh),		faceParSh,faceStepTail},
  { CMDFCTU(FP_Sw),		faceParSw,faceStepTail},
  { CMDFCTU(FP_Tl),		faceParTl,faceStepTail},
  { CMDFCTU(FP_Tr),		faceParTr,faceStepTail},
  { CMDFCTU(FP_Volume),		faceParVolume,faceVolume},
  { CMDFCTU(FP_Width), 		faceParWidth,faceWidth}
};

Men_t parMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, parCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======= */
				/* measure */
				/* ======= */
static Cmd_t measureActCmd[]= {
  { CMDFCT(FP_MeasureChiDy),		"dy-chi-square",NoArg},
  { CMDFCT(FP_MeasureChiY),		"y-chi-square",NoArg},
  { CMDFCT(FP_MeasurePoisson),		"poisson",NoArg}
};

Men_t measureActMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, measureActCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t measureDefCmd[]= {
  { CMDFCT(FP_MeasureDefChiDy),		"dy-chi-square",NoArg},
  { CMDFCT(FP_MeasureDefChiY),		"y-chi-square",NoArg},
  { CMDFCT(FP_MeasureDefPoisson),	"poisson",NoArg}
};

Men_t measureDefMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, measureDefCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t measureCmd[]= {
  { CMDMEN(&measureActMen),		"activate",NoArg},
  { CMDMEN(&measureDefMen),		"definition",NoArg}
};

Men_t measureMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, measureCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* === */
				/* cut */
				/* === */

				/* cut create */
static Cmd_t cutCreateCmd[]= {
  { CMDFCT(Cut_CreateCut),	"cut",NoArg},
  { CMDFCT(Cut_CreateHead),	"head",NoArg},
  { CMDFCT(Cut_CreateSpectrum),	"spectrum",NoArg},
  { DFLTFCT(Cut_CreateCut),	"cut",NoArg}
};

Men_t cutCreateMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutCreateCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut list */
static Cmd_t cutListCmd[]= {
  { CMDFCT(Cut_ListAll),	"all",NoArg},
  { CMDFCT(Cut_ListRange),	"range",NoArg},
  { DFLTFCT(Cut_ListRange),	"range",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t cutListMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, cutListCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut show */
static Cmd_t cutShowCmd[]= {
  { CMDFCT(DC_ManageCutOnly),	"spectrum",faceCutIdx},
  { CMDFCT(DC_ManagePro),	"projection",NoArg},
  { CMDFCT(DC_ManageGates),	"gate-marker",NoArg}
};

Men_t cutShowMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutShowCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut marker */
static Cmd_t cutMarkCmd[]= {
  { CMDFCT(Mrk_EnterGate),		"gate",faceMrkList},
  { CMDFCT(Mrk_EnterBgGate),		"bg-gate",faceMrkList},
  { CMDFCT(Mrk_EnterCut),		"cut",faceMrkList},
  { DFLTFCT(Mrk_EnterCut),		"cut",faceMrkList}
};

Men_t cutMarkMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutMarkCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* cut read cut */
static Cmd_t cutReadCutPosCmd[]= {
  { CMDFCT(Cut_ReadCutCursor),	"cursor",NoArg},
  { CMDFCT(Cut_ReadCutPos),	"value",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { REALFACE(Cut_ReadCutPos),	"value",NoArg}
};

Men_t cutReadCutPosMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutReadCutPosCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cutReadCutCmd[]= {
  { CMDFCT(Cut_ReadCutCursor),		"cursor",NoArg},
  { CMDFCT(Cut_ReadCutName),		"entry",faceCutName},
  { CMDMEN(&cutReadCutPosMen),		"position",facePos},
  { CMDFCT(Cut_ReadCutFirst),		"first",NoArg},
  { CMDFCT(Cut_ReadCutLast),		"last",NoArg},
  { CMDFCT(Cut_ReadCutNext),		"next",NoArg},
  { CMDFCT(Cut_ReadCutPrevious),	"previous",NoArg},
  { REALFCT(Cut_ReadCutPos),		"position",facePos},
  { DFLTFCT(Cut_ReadCutName),		"entry",faceCutName}
};

Men_t cutReadCutMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutReadCutCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut read head */
static Cmd_t cutReadHeadPosCmd[]= {
  { CMDFCT(Cut_ReadHeadCursor),	"cursor",NoArg},
  { CMDFCT(Cut_ReadHeadPos),	"value",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg},
  { REALFACE(Cut_ReadHeadPos),	"value",NoArg}
};

Men_t cutReadHeadPosMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutReadHeadPosCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cutReadHeadCmd[]= {
  { CMDFCT(Cut_ReadHeadCursor),		"cursor",NoArg},
  { CMDFCT(Cut_ReadHeadName),		"entry",faceCutName},
  { CMDMEN(&cutReadHeadPosMen),		"position",NoArg},
  { CMDFCT(Cut_ReadHeadFirst),		"first",NoArg},
  { CMDFCT(Cut_ReadHeadLast),		"last",NoArg},
  { CMDFCT(Cut_ReadHeadNext),		"next",NoArg},
  { CMDFCT(Cut_ReadHeadPrevious),	"previous",NoArg},
  { REALFCT(Cut_ReadHeadPos),		"position",facePos},
  { DFLTFCT(Cut_ReadHeadName),		"entry",faceCutName}
};

Men_t cutReadHeadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutReadHeadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut read */
static Cmd_t cutReadCmd[]= {
  { CMDMEN(&cutReadCutMen),	"cut",Menu},
  { CMDMEN(&cutReadHeadMen),	"head",Menu},
  { DFLTMENU(&cutReadCutMen),	"cut",Menu}
};

Men_t cutReadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutReadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut rm */
static Cmd_t cutRmCmd[]= {
  { CMDFCT(Cut_RmCut),		"cut",faceCutName},
  { CMDFCT(Cut_RmFit),		"fit",faceCutName},
  { CMDFCT(Cut_RmSpectrum),	"spectrum",faceCutName}
};

Men_t cutRmMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutRmCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut weight */
static Cmd_t cutWeightCmd[]= {
  { CMDFCT(Cut_WeightGat),	"gatewidth",NoArg},
  { CMDFCT(Cut_WeightFit),	"fit",NoArg}
};

Men_t cutWeightMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutWeightCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* cut write */
static Cmd_t cutWriteCmd[]= {
  { CMDFCT(Cut_WriteCut),	"cut",NoArg},
  { CMDFCT(Cut_WriteHead),	"head",NoArg}
};

Men_t cutWriteMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutWriteCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* cut path */
				/* ======== */
static char faceCutPathToken[]= "<directory-idx> <filename>";

static Cmd_t cutPathCmd[]= {
  { CMDFCT(Cut_CutPathClose),	"close",faceCutPathIdx},
  { CMDFCT(Cut_CutFormat),	"format",faceFormat},
  { CMDFCT(Cut_CutPathOpen),	"open",faceCutPathToken},
  { CMDFCT(Cut_ShowCutPath),	"status",NoArg},
  { DFLTFCT(Cut_CutPathOpen),	"open",faceCutPathToken}
};

Men_t cutPathMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutPathCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ====== */
				/* matrix */
				/* ====== */
static char faceMtxToken[]= "<mtx-idx> <filename>";

static Cmd_t cutMatrixCmd[]= {
  { CMDFCT(Cut_ProIdx),		"attach-projection","<mtx-idx> <spc-idx>"},
  { CMDFCT(Cut_MtxClose),	"close",faceMtxIdx},
  { CMDFCT(Cut_MtxFormat),	"format",faceFormat},
  { CMDFCT(Cut_MtxOpen),	"open",faceMtxToken},
  { CMDFCT(Cut_ShowMtx),	"status",NoArg},
  { DFLTFCT(Cut_MtxOpen),	"open",faceMtxToken}
};

Men_t cutMatrixMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutMatrixCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cutScaleCmd[]= {
  { CMDFCT(Cut_Scale),		"i/o",faceScale},
  { CMDFCT(Mrk_ScaleCut),	"marker",faceScale}
};

Men_t cutScaleMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutScaleCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cutAttachCmd[]= {
  { CMDFCT(Cut_CutPathIdx),	"directory","<directory-idx>"},
  { CMDFCT(Cut_MtxIdx),		"matrix","<mtx-idx>"},
  { CMDFCT(Cut_SpcIdx),		"spectrum","<spc-idx>"}
};

Men_t cutAttachMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutAttachCmd),
  VecSETUP(Cmd_t, defaultSpecial) };


				/* cut root */
static Cmd_t cutCmd[]= {
  { CMDFCT(Act_ReadActCut),	"activate",faceCutIdx},
  { CMDMEN(&cutAttachMen),	"attach",Menu},
  { CMDMEN(&cutCreateMen),	"create",Menu},
  { CMDMEN(&cutPathMen),	"directory",Menu},
  { CMDFCT(Cut_EnvOpen),	"environment","<root-directory>"},
  { CMDMEN(&cutListMen),	"list",Menu},
  { CMDMEN(&mrkCutMen),		"marker",Menu},
  { CMDMEN(&cutMatrixMen),	"matrix",Menu},
  { CMDMEN(&cutReadMen),	"read",Menu},
  { CMDMEN(&cutRmMen),		"rm",Menu},
  { CMDFCT(Cut_ShowCut),	"status",NoArg},
  { CMDMEN(&cutScaleMen),	"scale",Menu},
  { CMDFCT(Cut_Use),		"use-marker",faceCutIdx},
  { CMDMEN(&cutWriteMen),	"write",Menu},
  { CMDMEN(&cutWeightMen),	"weight",Menu}
};

Men_t cutMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cutCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* =========== */
				/* result-file */
				/* =========== */

				/* default */
static Cmd_t resultFmtDefCmd[]= {
  { CMDFCT(FW_FmtDefBgPol),	"bg-polynom",NoArg},
  { CMDFCT(FW_FmtDefBgExp),	"bg-exponential",NoArg},
  { CMDFCT(FW_FmtDefFit),	"fit",NoArg},
  { CMDFCT(FW_FmtDefInt),	"integration",NoArg},
  { CMDFCT(FW_FmtDefMark),	"mark",NoArg},
  { CMDFCT(FW_FmtDefPeakFit),	"peak-fit",NoArg},
  { CMDFCT(FW_FmtDefPeakInt),	"peak-integration",NoArg},
  { CMDFCT(FW_FmtDefPeakSea),	"peak-search",NoArg}
};

Men_t resultFmtDefMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultFmtDefCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* enter */
static Cmd_t resultFmtEnterCmd[]= {
  { CMDFCT(FW_FmtEnterBgPol),	"bg-polynom",NoArg},
  { CMDFCT(FW_FmtEnterBgExp),	"bg-exponential",NoArg},
  { CMDFCT(FW_FmtEnterFit),	"fit",NoArg},
  { CMDFCT(FW_FmtEnterInt),	"integration",NoArg},
  { CMDFCT(FW_FmtEnterMark),	"mark",NoArg},
  { CMDFCT(FW_FmtEnterPeakFit),	"peak-fit",NoArg},
  { CMDFCT(FW_FmtEnterPeakInt),	"peak-integration",NoArg},
  { CMDFCT(FW_FmtEnterPeakSea),	"peak-search",NoArg}
};

Men_t resultFmtEnterMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultFmtEnterCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* read */
static Cmd_t resultFmtReadCmd[]= {
  { CMDFCT(FW_FmtReadBgPol),	"bg-polynom",NoArg},
  { CMDFCT(FW_FmtReadBgExp),	"bg-exponential",NoArg},
  { CMDFCT(FW_FmtReadFit),	"fit",NoArg},
  { CMDFCT(FW_FmtReadInt),	"integration",NoArg},
  { CMDFCT(FW_FmtReadMark),	"mark",NoArg},
  { CMDFCT(FW_FmtReadPeakFit),	"peak-fit",NoArg},
  { CMDFCT(FW_FmtReadPeakInt),	"peak-integration",NoArg},
  { CMDFCT(FW_FmtReadPeakSea),	"peak-search",NoArg}
};

Men_t resultFmtReadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultFmtReadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* write */
static Cmd_t resultFmtWriteCmd[]= {
  { CMDFCT(FW_FmtWriteBgPol),	"bg-polynom",NoArg},
  { CMDFCT(FW_FmtWriteBgExp),	"bg-exponential",NoArg},
  { CMDFCT(FW_FmtWriteFit),	"fit",NoArg},
  { CMDFCT(FW_FmtWriteInt),	"integration",NoArg},
  { CMDFCT(FW_FmtWriteMark),	"mark",NoArg},
  { CMDFCT(FW_FmtWritePeakFit),	"peak-fit",NoArg},
  { CMDFCT(FW_FmtWritePeakInt),	"peak-integration",NoArg},
  { CMDFCT(FW_FmtWritePeakSea),	"peak-search",NoArg}
};

Men_t resultFmtWriteMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultFmtWriteCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* result-format root */
static Cmd_t resultFmtCmd[]= {
  { CMDMEN(&resultFmtDefMen),	"default",faceTokenIdxList},
  { CMDMEN(&resultFmtEnterMen),	"enter",faceTokenIdxList},
  { CMDMEN(&resultFmtReadMen),	"read",Menu},
  { CMDFCT(FW_FmtShow),		"status",NoArg},
  { CMDMEN(&resultFmtWriteMen),	"write",Menu}
};

Men_t resultFmtMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultFmtCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t resultCmd[]= {
  { CMDFCT(FW_AppendFile),	"append-open",NoArg},
  { CMDFCT(FW_CloseFile),	"close",NoArg},
  { CMDMEN(&resultFmtMen),	"format",Menu},
  { CMDFCT(FW_OpenFile),	"open",NoArg}
};

Men_t resultMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,resultCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* === */
				/* fit */
				/* === */

				/* bg function */
static Cmd_t bgFunctionCmd[]= {
  { CMDFCT(FP_BgFunctionDefPol),	"definition",Menu}
};

Men_t bgFunctionMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,bgFunctionCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* fit function */
static Cmd_t pkFunctionActCmd[]= {
  { CMDFCT(FP_FunctionActCA),	"continuous-exp-tail/arctan-step",NoArg},
  { CMDFCT(FP_FunctionActAE),	"additive-tail/erf-step",NoArg}
};

Men_t pkFunctionActMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,pkFunctionActCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t pkFunctionDefCmd[]= {
  { CMDFCT(FP_FunctionDefCA),	"continuous-exp-tail/arctan-step",NoArg},
  { CMDFCT(FP_FunctionDefAE),	"additive-tail/erf-step",NoArg}
};

Men_t pkFunctionDefMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,pkFunctionDefCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t pkFunctionExpCmd[]= {
  { CMDFCT(FP_ExponentTl),	"tl",faceExponent},
  { CMDFCT(FP_ExponentTr),	"tr",faceExponent}
};

Men_t pkFunctionExpMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,pkFunctionExpCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t pkFunctionCmd[]= {
  { CMDMEN(&pkFunctionActMen),	"activate",Menu},
  { CMDMEN(&pkFunctionDefMen),	"definition",Menu},
  { CMDMEN(&pkFunctionExpMen),	"exponent",Menu}
};

Men_t pkFunctionMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,pkFunctionCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t functionCmd[]= {
  { CMDMEN(&bgFunctionMen),	"background",Menu},
  { CMDMEN(&pkFunctionMen),	"peak",Menu}
};

Men_t functionMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,functionCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* fit show */
static Cmd_t fitShowCmd[]= {
  { CMDFCT(DB_Manage),		"bin-list",NoArg},
  { CMDFCT(DD_Manage),		"decomposition",NoArg},
  { CMDFCT(DF_Manage),		"function/marker",NoArg}
};

Men_t fitShowMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitShowCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t fitHideCmd[]= {
  { CMDFCT(DB_Unmanage),	"bin-list",NoArg},
  { CMDFCT(DD_Unmanage),	"decomposition",NoArg},
  { CMDFCT(DF_Unmanage),	"function/marker",NoArg}
};

Men_t fitHideMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitHideCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* fit read bin */
static Cmd_t fitReadBinCmd[]= {
  { CMDFCT(Fio_ReadBinPos),		"position",facePos},
  { CMDFCT(Fio_ReadBinFirst),		"first",NoArg},
  { CMDFCT(Fio_ReadBinLast),		"last",NoArg},
  { CMDFCT(Fio_ReadBinNext),		"next",NoArg},
  { CMDFCT(Fio_ReadBinPrevious),	"previous",NoArg},
  { CMDFCT(Fio_ReadBinIndex),		"index",faceIdx},
  { INTFCT(Fio_ReadBinIndex),		"index",faceIdx},
  { REALFCT(Fio_ReadBinPos),		"position",facePos}
};

Men_t fitReadBinMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitReadBinCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit read fit */
static Cmd_t fitReadFitCmd[]= {
  { CMDFCT(Fio_ReadFitFirst),		"first",NoArg},
  { CMDFCT(Fio_ReadFitLast),		"last",NoArg},
  { CMDFCT(Fio_ReadFitNext),		"next",NoArg},
  { CMDFCT(Fio_ReadFitPrevious),	"previous",NoArg}
};

Men_t fitReadFitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitReadFitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit read integration */
static Cmd_t fitReadIntCmd[]= {
  { CMDFCT(Fio_ReadIntFirst),		"first",NoArg},
  { CMDFCT(Fio_ReadIntLast),		"last",NoArg},
  { CMDFCT(Fio_ReadIntNext),		"next",NoArg},
  { CMDFCT(Fio_ReadIntPrevious),	"previous",NoArg}
};

Men_t fitReadIntMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitReadIntCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit read record*/
static Cmd_t fitReadRecCmd[]= {
  { CMDFCT(Fio_ReadRecFirst),		"first",NoArg},
  { CMDFCT(Fio_ReadRecLast),		"last",NoArg},
  { CMDFCT(Fio_ReadRecNext),		"next",NoArg},
  { CMDFCT(Fio_ReadRecPrevious),	"previous",NoArg},
  { CMDFCT(Fio_ReadRecIndex),		"index",faceIdx}
};

Men_t fitReadRecMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitReadRecCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit read */
static Cmd_t fitReadCmd[]= {
  { CMDMEN(&fitReadBinMen),	"bin",Menu},
  { CMDMEN(&fitReadFitMen),	"fit",Menu},
  { CMDMEN(&fitReadIntMen),	"integration",Menu},
  { CMDMEN(&fitReadRecMen),	"record",Menu},
  { DFLTMENU(&fitReadBinMen),	"bin",Menu}
};

Men_t fitReadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitReadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit scale */
static Cmd_t fitScaleCmd[]= {
  { CMDFCT(Fit_InScale),	"input",faceScale},
  { CMDFCT(Mrk_ScaleFit),	"marker",faceScale},
  { CMDFCT(Fit_OutScale),	"output",faceScale}
};

Men_t fitScaleMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitScaleCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* =========== */
				/* peak-list */
				/* =========== */
static Cmd_t peakCmd[]= {
  { CMDFCT(FW_ListPeaklist),	"list",faceIdxActRange},
  { CMDFCT(FW_PrintPeaklist),	"print",faceIdxActRange},
  { CMDFCT(Fio_PeakRead),	"read",faceIdxListAct}
};

Men_t peakMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,peakCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* =========== */
				/* search-list */
				/* =========== */
static Cmd_t searchCmd[]= {
  { CMDFCT(FW_ListSea),		"list",faceIdxActRange},
  { CMDFCT(Sea_Search),		"create",faceIdxListAct},
  { CMDMEN(&mrkSeaMen),		"marker",Menu},
  { CMDFCT(Fio_Open),		"open",faceIdxListAct},
  { CMDFCT(FW_PrintSea),	"print","[<idx>]"},
  { CMDFCT(Sea_Prob),		"probability",faceMrkList},
  { CMDFCT(Sea_Read),		"read",faceIdxListAct},
  /*  { CMDMEN(&resultMen),		"result-file",Menu},*/
  { CMDFCT(Mrk_ScaleFitSea),	"scale",faceScale},
  { CMDFCT(FW_ShowSea),		"status",NoArg},
  { CMDFCT(Sea_Write),		"write",faceIdxListAct}
};

Men_t searchMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,searchCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t fitStatCmd[]= {
  { CMDFCT(FW_ShowFit),		"full",NoArg},
  { CMDFCT(FW_ShortFit),	"short",NoArg}/*,
  { DFLTFCT(FW_ShowFit),	"full",NoArg}*/
};
Men_t fitStatMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitStatCmd),
  VecSETUP(Cmd_t, defaultSpecial) };
				/* fit root */
static Cmd_t fitCmd[]= {
  { CMDMEN(&activateSpectrumMen),"activate",Menu},
  { CMDFCT(Fit_Bg),		"background-create","<degree>"},
  { CMDMEN(&bgFunctionMen),	"bg-function",Menu},
  { CMDFCT(Fit_Region),		"region-create",faceIdxListAct},
  { CMDFCT(Fit_Integrate),	"integration-create",faceIdxListAct},
  { CMDFCT(Fit_Delete),		"delete",NoArg},
  { CMDMEN(&functionMen),	"function",Menu},
  { CMDFCT(FW_ListFit),		"list",faceIdxAct},
  { CMDMEN(&mrkFitMen),		"marker",Menu},
  { CMDMEN(&measureMen),	"measure",Menu},
  { CMDFCT(Fio_Open),		"open",faceIdxListAct},
  { CMDMENU(&parMen),		"parameter",Menu},
  { CMDMEN(&peakMen),		"peaklist",Menu},
  { CMDFCT(FW_PrintFit),	"print",NoArg},
  { CMDMEN(&searchMen),		"psearch",Menu},
  { CMDMEN(&fitReadMen),	"read",Menu},
  { CMDFCT(Fit_Recover),	"recover-backup",faceIdxListAct},
  { CMDFCT(Fit_Restore),	"restore",NoArg},
  { CMDMEN(&resultMen),		"result-file",Menu},
  { CMDMEN(&fitStatMen),	"status",Menu},
  { CMDMEN(&fitScaleMen),	"scale",Menu},
  { CMDFCT(Fit_Store),		"store",NoArg},
  { CMDFCT(Fit_Use),		"use-fitdata",faceIdxAct},
  { CMDFCT(Fio_Write),		"write",faceIdxListAct},
  { DFLTFCT(Fit_Region),	"region-create",faceIdxListAct}
};

Men_t fitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t fioAskCmd[]= {
  { CMDFCT(Fio_No),	"no",NoArg},
  { CMDFCT(Fio_Yes),	"yes",NoArg}
};

Men_t fioAskMen= {
  UFLSINGLE,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,fioAskCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* keytable */
				/* ======== */
static Cmd_t keyReadCmd[]= {
  { CMDFCT(KT_ReadMerge),	"merge",faceKeyFile},
  { CMDFCT(KT_ReadReplace),	"replace",faceKeyFile},
  { DFLTFCT(KT_ReadReplace),	"merge",faceKeyFile}
};

Men_t keyReadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,keyReadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t keytableCmd[]= {
  { CMDFCT(KT_Activate),	"activate",faceKeyTitle},
  { CMDFCT(KT_Ascii),		"ascii","[<char-value> [<char-value>]]"},
  { CMDFCT(KT_Create),		"create",faceKeyTitle},
  { CMDFCT(KT_Delete),		"delete",faceKeyTitle},
  { CMDFCT(KT_List),		"list",NoArg},
  { CMDMEN(&keyReadMen),	"read",Menu},
  { CMDFCT(KT_Show),		"status",NoArg},
  { CMDFCT(KT_Write),		"write",faceKeyFileTitle}
};

Men_t keytableMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,keytableCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ===== */
				/* label */
				/* ===== */
static Cmd_t labelShowCmd[]= {
  { CMDFCT(DCL_Manage),		"cut",NoArg},
  { CMDFCT(DPL_Manage),		"peaklist",NoArg},
  { CMDFCT(DL_Manage),		"user",NoArg}
};

Men_t labelShowMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelShowCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelHideCmd[]= {
  { CMDFCT(DCL_Unmanage),	"cut",NoArg},
  { CMDFCT(DPL_Unmanage),	"peaklist",NoArg},
  { CMDFCT(DL_Unmanage),	"user",NoArg}
};

Men_t labelHideMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelHideCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* label cut */
static Cmd_t labelCutParCmd[]= {
  { CMDFCT(DL_CutLibrary),	"library",faceLabelTitle},
  { CMDFCT(DL_CutCalib),	"calibrated",NoArg},
  { CMDFCT(DL_CutNoCalib),	"nocalibrated",NoArg},
  { CMDFCT(DL_CutUncalib),	"uncalibrated",NoArg},
  { CMDFCT(DL_CutNoUncalib),	"nouncalibrated",NoArg},
  { CMDFCT(DL_CutString),	"string",NoArg},
  { CMDFCT(DL_CutNoString),	"nostring",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t labelCutParMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelCutParCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelCutCmd[]= {
  { CMDMEN(&labelCutParMen),	"parameter",Menu},
  { CMDFCT(DL_ShowActCut),	"status",NoArg},
  { CMDFCT(DL_WriteCut),	"write",faceLabelFile}
};

Men_t labelCutMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelCutCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* label fit */
static Cmd_t labelFitParCmd[]= {
  { CMDFCT(DL_FitLibrary),	"library",faceLabelTitle},
  { CMDFCT(DL_FitCalib),	"calibrated",NoArg},
  { CMDFCT(DL_FitNoCalib),	"nocalibrated",NoArg},
  { CMDFCT(DL_FitUncalib),	"uncalibrated",NoArg},
  { CMDFCT(DL_FitNoUncalib),	"nouncalibrated",NoArg},
  { CMDFCT(DL_FitString),	"string",NoArg},
  { CMDFCT(DL_FitNoString),	"nostring",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t labelFitParMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelFitParCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelFitCmd[]= {
  { CMDMEN(&labelFitParMen),	"parameter",Menu},
  { CMDFCT(DL_ShowActFit),	"status",NoArg},
  { CMDFCT(DL_WriteFit),	"write",faceLabelFile}
};

Men_t labelFitMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelFitCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* label peaklist */
static Cmd_t labelPeakParCmd[]= {
  { CMDFCT(DL_PeaklistLibrary),	"library",faceLabelTitle},
  { CMDFCT(DL_PeaklistCalib),	"calibrated",NoArg},
  { CMDFCT(DL_PeaklistNoCalib),	"nocalibrated",NoArg},
  { CMDFCT(DL_PeaklistUncalib),	"uncalibrated",NoArg},
  { CMDFCT(DL_PeaklistNoUncalib),"nouncalibrated",NoArg},
  { CMDFCT(DL_PeaklistString),	"string",NoArg},
  { CMDFCT(DL_PeaklistNoString),"nostring",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t labelPeakParMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelPeakParCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelPeakCmd[]= {
  { CMDMEN(&labelPeakParMen),	"parameter",Menu},
  { CMDFCT(DL_ShowActPeaklist),	"status",NoArg},
  { CMDFCT(DL_WritePeaklist),	"write",faceLabelFile}
};

Men_t labelPeakMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelPeakCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* label user */
static Cmd_t labelDeleteCmd[]= {
  { CMDFCT(DL_DeleteLabelAll),		"all",NoArg},
  { CMDFCT(DL_DeleteLabelCursor),	"cursor",NoArg},
  { CMDFCT(DL_Delete),			"list",faceLabelTitle}
};

Men_t labelDeleteMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelDeleteCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelUserParCmd[]= {
  { CMDFCT(DL_UserLibrary),	"library",faceLabelTitle},
  { CMDFCT(DL_UserCalib),	"calibrated",NoArg},
  { CMDFCT(DL_UserNoCalib),	"nocalibrated",NoArg},
  { CMDFCT(DL_UserUncalib),	"uncalibrated",NoArg},
  { CMDFCT(DL_UserNoUncalib),	"nouncalibrated",NoArg},
  { CMDFCT(DL_UserString),	"string",NoArg},
  { CMDFCT(DL_UserNoString),	"nostring",NoArg},
  { LQBFACE(UFMenuLoopExit),	"Exit",NoArg}
};

Men_t labelUserParMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelUserParCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelUserReadCmd[]= {
  { CMDFCT(DL_ReadMerge),	"merge",faceLabelOFile},
  { CMDFCT(DL_ReadReplace),	"replace",faceLabelOFile},
  { DFLTFCT(DL_ReadReplace),	"replace",faceLabelOFile}
};

Men_t labelUserReadMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelUserReadCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelStatusCmd[]= {
  { CMDFCT(DL_ShowActUser),	"active",NoArg},
  { CMDFCT(DL_ShowLists),	"existing",NoArg}
};

Men_t labelStatusMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelStatusCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelUserCmd[]= {
  { CMDFCT(DL_Activate),	"activate",faceLabelTitle},
  { CMDFCT(DL_Create),		"create",faceLabelTitleScale},
  { CMDMEN(&labelDeleteMen),	"delete",Menu},
  { CMDFCT(DL_EnterLabel),	"enter",faceLabelText},
  { CMDMEN(&labelUserParMen),	"parameter",Menu},
  { CMDMEN(&labelUserReadMen),	"read",Menu},
  { CMDFCT(DL_Scale),		"scale",faceLabelTitleScale},
  { CMDMEN(&labelStatusMen),	"status",Menu},
  { CMDFCT(DL_WriteUser),	"write",faceLabelFileTitle}
};

Men_t labelUserMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelUserCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t labelCmd[]= {
  { CMDMEN(&labelCutMen),	"cut",Menu},
  { CMDMEN(&labelFitMen),	"fit",Menu},
  { CMDMEN(&labelPeakMen),	"peaklist",Menu},
  { CMDMEN(&labelUserMen),	"user",Menu},
  { DFLTMENU(&labelUserMen),	"user",Menu}
};

Men_t labelMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,labelCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ============== */
				/* display create */
				/* ============== */
static Cmd_t windowCreateCmd[]= {
  { CMDFACE(DW_CreateSimpleShell),	"simple",faceWindow},
  { CMDFACE(DW_CreateCutShell),		"cut",faceWindow},
  { CMDFACE(DW_CreateFitShell),		"fit",faceWindow},
  { CMDFACE(DW_CreatePanedShell),	"paned",faceWindowNum},
  { CMDFACE(DW_CreateXPanedShell),	"xpaned",faceWindowNum},
  { CMDFACE(DW_CreateYPanedShell),	"ypaned",faceWindowNum}
};

Men_t windowCreateMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,windowCreateCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======= */
				/* display */
				/* ======= */
static Cmd_t inputModeCmd[]= {
  { CMDFCT(DW_InputModeMouse),		"cursor",NoArg},
  { CMDFCT(DW_InputModeEdit),		"edit",NoArg}
};

Men_t inputModeMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,inputModeCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t lockFocusCmd[]= {
  { CMDFCT(DW_LockWidget),		"title",faceSubWindow},
  { CMDFCT(DW_LockWidgetCursor),	"cursor",NoArg},
  { CMDFCT(DW_UnlockWidget),		"none",NoArg},
  { DFLTFCT(DW_LockWidget),		"title",faceSubWindow}
};

Men_t lockFocusMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,lockFocusCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t windowNormCmd[]= {
  { CMDFCT(VdNormalizedDisplay),	"on",NoArg},
  { CMDFCT(VdUnnormalizedDisplay),	"off",NoArg}
};

Men_t windowNormMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,windowNormCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t displayHistoCompressCmd[]= {
  { CMDFCT(DS_DrawEach),		"each",NoArg},
  { CMDFCT(DS_DrawFirstFound),		"first-found",NoArg},
  { CMDFCT(DS_DrawMinMax),		"min-max",NoArg}
};

Men_t displayHistoCompressMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,displayHistoCompressCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ===== */
				/* frame */
				/* ===== */
static Cmd_t frameCmd[]= {
  { CMDFCT(DA_Distance),	"distances",faceFrameDistance},
  { CMDFCT(DA_Tic),		"lengths",faceFrameLength},
  { CMDFCT(DA_Frame),		"widths",faceFrameWidth}
};

Men_t frameMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,frameCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ==== */
				/* plot */
				/* ==== */
static Cmd_t plotCreateCmd[]= {
  { CMDFCT(DP_PlotUnix),	"unix-plot",faceFile},
  { CMDFCT(DP_PlotXfig),	"xfig",faceFile}
};

Men_t plotCreateMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,plotCreateCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t plotFormatCmd[]= {
  { CMDFCT(DP_CmFormat),	"cm-format","<width-cm> <height-cm>"},
  { CMDFCT(DP_PxFormat),	"px-format","<width-px> <height-px>"},
  { CMDFCT(DP_PtsPerInch),	"pts/inch","<x-pts/in> <y-pts/in>"},
  { CMDFCT(DP_Fontscale),	"fontscale-factor","<factor>"}
};

Men_t plotFormatMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,plotFormatCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t plotCmd[]= {
  { CMDMEN(&plotCreateMen),	"create",Menu},
  { CMDMEN(&plotFormatMen),	"format",Menu},
  { DFLTMENU(&plotCreateMen),	"create",Menu}
};

Men_t plotMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,plotCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* wildcard */
				/* ======== */
static Cmd_t wildcardCmd[]= {
  { CMDFCT(Pth_PatternDel),	"delete",faceWildcard},
  { CMDFCT(Pth_PatternSet),	"enter","<wildcard> <expression>"},
  { CMDFCT(Pth_PatternShow),	"status",NoArg}
};

Men_t wildcardMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,wildcardCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======= */
				/* scaling */
				/* ======= */
static Cmd_t yFunctionCmd[]= {
  { CMDFCT(DSc_Linear),			"linear",NoArg},
  { CMDFCT(DSc_Logarithmic),		"logarithmic",NoArg},
  { CMDMEN(&windowNormMen),		"normalization",Menu},
  { CMDFCT(DSc_Squared),		"squared",NoArg}
};

Men_t yFunctionMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,yFunctionCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t yModificationCmd[]= {
  { CMDFCT(DSc_ModificationNone),	"no-modification",NoArg},
  { CMDFCT(DSc_ModificationEfficiency),	"efficiency",NoArg},
  { CMDFCT(DSc_ModificationMultiplied),	"multiplied",NoArg}
};

Men_t yModificationMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,yModificationCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t scalingCmd[]= {
  { CMDMEN(&yFunctionMen),	"function-y",Menu},
  { CMDMEN(&yModificationMen),	"modification-y",Menu},
  { CMDFCT(Act_WidgetScale),	"scale-x",faceScale}
};

Men_t scalingMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,scalingCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cursorSubWinCmd[]= {
  { CMDFCT(DCs_CrossHairCursor),	"cross-hair",NoArg},
  { CMDFCT(DCs_DopplerCursor),	"doppler","<doppler factor>"},
  { CMDFCT(DCs_GridCursor),		"grid","<elements> <offset>"}
};

Men_t cursorSubWinMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cursorSubWinCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t cursorCmd[]= {
  { CMDFCT(DCs_ShellCursorCross),	"cross-hair",NoArg},
  { CMDFCT(DCs_ShellCursorVert),	"vertical",NoArg},
  { CMDMEN(&cursorSubWinMen),		"subwindow",Menu}
};

Men_t cursorMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cursorCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ==== */
				/* view */
				/* ==== */
static Cmd_t viewCenterCmd[]= {
  { CMDFCT(DSc_Center),		"both","<x-center> [cal.|uncal.] <y-center>"},
  { CMDFCT(DSc_CenterX),	"x","<x-center> [cal.|uncal.]"},
  { CMDFCT(DSc_CenterY),	"y","<y-center>"}
};

Men_t viewCenterMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,viewCenterCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t viewFullCmd[]= {
  { CMDFCT(DSc_Full),		"both",NoArg},
  { CMDFCT(DSc_FullX),		"x",NoArg},
  { CMDFCT(DSc_FullY),		"y",NoArg}
};

Men_t viewFullMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,viewFullCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t viewResetCmd[]= {
  { CMDFCT(DSc_Reset),		"both",NoArg},
  { CMDFCT(DSc_ResetX),		"x",NoArg},
  { CMDFCT(DSc_ResetY),		"y",NoArg}
};

Men_t viewResetMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,viewResetCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t viewCmd[]= {
  { CMDMEN(&viewCenterMen),	"center",Menu},
  { CMDFCT(DSc_Expand),		"expand",NoArg},
  { CMDMEN(&viewFullMen),	"full",Menu},
  { CMDFCT(DSc_Position),	"position",
      "<width> <position> [calibrated|uncalibrated]"},
  { CMDFCT(DSc_Shift),		"shift","<x-percent> <y-percent>"},
  { CMDFCT(DSc_Stretch),	"stretch",
      "<-log2(x-fac)> [<x> [cal.|uncal.]] <-log2(y-fac)> [<y> [cal.|uncal.]]"},
  { CMDMEN(&viewResetMen),	"reset",Menu}
};

Men_t viewMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,viewCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ==== */
				/* show */
				/* ==== */
static Cmd_t showMarkCmd[]= {
  { CMDFCT(DM_ManageCut),	"cut",NoArg},
  { CMDFCT(DM_ManageFit),	"fit",NoArg},
  { CMDFCT(DM_ManageNrm),	"normalization",NoArg},
  { CMDFCT(DM_ManageRcl),	"recalibration",NoArg},
  { CMDFCT(DM_ManageSea),	"psearch",NoArg}
};

Men_t showMarkMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,showMarkCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t showCmd[]= {
  { CMDMEN(&cutShowMen),	"cut",Menu},
  { CMDMEN(&fitShowMen),	"fit",Menu},
  { CMDMEN(&labelShowMen),	"labellist",Menu},
  { CMDMEN(&showMarkMen),	"marker",Menu},
  { CMDFCT(DPS_Manage),		"peaklist",NoArg},
  { CMDMEN(&spcShowMen),	"spectrum",Menu},
  { CMDFCT(VdShowAct),		"status",NoArg},
  { DFLTMENU(&spcShowMen),	"spectrum",Menu}
};

Men_t showMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,showCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ==== */
				/* hide */
				/* ==== */
static Cmd_t hideMarkCmd[]= {
  { CMDFCT(DM_UnmanageCut),	"cut",NoArg},
  { CMDFCT(DM_UnmanageFit),	"fit",NoArg},
  { CMDFCT(DM_UnmanageNrm),	"normalization",NoArg},
  { CMDFCT(DM_UnmanageRcl),	"recalibration",NoArg},
  { CMDFCT(DM_UnmanageSea),	"psearch",NoArg}
};

Men_t hideMarkMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,hideMarkCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t hideCmd[]= {
  { CMDFCT(DC_UnmanageGates),	"cut-gate-marker",NoArg},
  { CMDMEN(&fitHideMen),	"fit",Menu},
  { CMDMEN(&hideMarkMen),	"marker",Menu},
  { CMDMEN(&labelHideMen),	"labellist",Menu},
  { CMDFCT(DPS_Unmanage),	"peaklist",NoArg},
  { CMDFCT(DS_UnmanageNames),	"spectrum-names",NoArg}
};

Men_t hideMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,hideCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======== */
				/* protocol */
				/* ======== */
static Cmd_t cmdProtocCmd[]= {
  { CMDFACE(UF_CloseCmdFile),	"close",NoArg},
  { CMDFACE(UF_OpenCmdFile),	"open",faceOutput}
};

Men_t cmdProtocMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,cmdProtocCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t sessionProtocCmd[]= {
  { CMDFACE(UF_CloseOutFile),	"close",NoArg},
  { CMDFACE(UF_OpenOutFile),	"open",faceOutput}
};

Men_t sessionProtocMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,sessionProtocCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t stdProtocCmd[]= {
  { CMDFACE(UF_CloseStdFile),	"close",NoArg},
  { CMDFACE(UF_OpenStdFile),	"open",NoArg}
};

Men_t stdProtocMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,stdProtocCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t protocolCmd[]= {
  { CMDMEN(&cmdProtocMen),	"command",Menu},
  { CMDMEN(&sessionProtocMen),	"session",Menu},
  { CMDMEN(&stdProtocMen),	"standard-output",Menu}
};

Men_t protocolMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,protocolCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t windowSetupCmd[]= {
  { CMDMEN(&cursorMen),			"cursor",Menu},
  { CMDMEN(&frameMen),			"frame",Menu},
  { CMDMEN(&displayHistoCompressMen),	"histogram-compression",Menu},
  { CMDMEN(&lockFocusMen),		"keyboard-focus",Menu}
};

Men_t windowSetupMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,windowSetupCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t windowCmd[]= {
  { CMDMEN(&windowCreateMen),		"create",Menu},
  { CMDFACE(DW_DestroyShell),		"delete",faceWindow},
  { CMDMEN(&hideMen),			"hide",Menu},
  { CMDFCT(VdShowShells),		"list",NoArg},
  { CMDMEN(&mrkWinMen),			"marker",Menu},
  { CMDMEN(&plotMen),			"plot",Menu},
  { CMDFCT(VdRaiseShell),		"raise",faceWindow},
  { CMDFCT(DSc_Redisplay),		"redisplay",NoArg},
  { CMDMEN(&scalingMen),		"scaling",Menu},
  { CMDMEN(&windowSetupMen),		"setup",Menu},
  { CMDMEN(&showMen),			"show",Menu},
  { CMDFCT(VdShowAct),			"status",NoArg},
  { CMDMEN(&viewMen),			"view",Menu}
};

Men_t windowMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,windowCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

static Cmd_t displayCmd[]= {
  { CMDFCT(VdResume),			"resume",NoArg},
  { CMDFCT(VdResumeForced),		"resume-forced",NoArg},
  { CMDFCT(VdSuspend),			"suspend",NoArg}
};

Men_t displayMen= {
  UFLSINGLELOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t,displayCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

				/* ======= */
				/* tv root */
				/* ======= */
static Cmd_t rootTvCmd[]= {
  { CMDCOMMENT,			"main command groups:\n",NoArg},

  { CMDMEN(&calMen),		"calibration",Menu},
  { CMDMEN(&cutMen),		"cut",Menu},
  { CMDMEN(&fitMen),		"fit",Menu},
  { CMDMEN(&labelMen),		"label",Menu},
  { CMDMEN(&nrmMen),		"normalization",Menu},
  { CMDMEN(&rclMen),		"recalibration",Menu},
  { CMDMEN(&spcMen),		"spectrum",Menu},
  { CMDMEN(&windowMen),		"window",Menu},

  { CMDCOMMENT,			"\nmiscellaneous:\n",NoArg},

  { CMDFCT(MainReadMe),		"ReadMe",NoArg},
#ifdef UltrixArchitecture
  { CMDFCT(Leave_ServerMode),	"client",NoArg},
#endif
  { CMDFCT(Pth_ChDir),		"cd","<path>"},
  { CMDMEN(&cmdFileMen),	"command-file",Menu},
  { CMDFCT(DW_EditFocusLock),	"edit-lock",NoArg},
  /*  { CMDFCT(DW_EditFocusUnlock),	"edit-unlock",NoArg},*/
  { CMDMEN(&displayMen),	"graphic",Menu},
  { CMDMEN(&inputModeMen),	"input-mode",Menu},
  { CMDFCT(KT_KeyAlias),	"keyalias","[<keysequence> [<alias>]]"},
  { CMDFCT(KT_KeyUnalias),	"keyunalias","<keysequence>"},
  { CMDMEN(&keytableMen),	"keytable",Menu},
  { CMDFCT(Mrk_Precision),	"precision","<precision>"},
  { CMDMEN(&protocolMen),	"protocol",Menu},
#ifdef UltrixArchitecture
  { CMDFCT(Enter_ServerMode),	"server",NoArg},
#endif
  { CMDFCT(UF_Which),		"which","[<config/command-file>]"},
  { CMDMEN(&wildcardMen),	"wildcard",Menu},
  { UFECMD,   FALSE, 4, OPFACE(UFMenuLoopExit),	"exit",NoArg},
  { LQBFACE(UFRootLoopQBreak),	"Continue",NoArg},
  { UFELOOPTAIL, FALSE, 0, OPFACE(UFRootLoopQBreak),	"Continue",NoArg}
};

Men_t rootTvMen= {
  UFLLOOP,
  NULL,
  VecINIT(Cmd_t),
  VecSETUP(Cmd_t, rootTvCmd),
  VecSETUP(Cmd_t, defaultSpecial) };

#endif				/* _VsFace_h */
