/* VsFit.c */
static int Fit_VfitInit P_((Vfit_t *vp));
static int Fit_VReset P_((Vfit_t *vp));
static int Fit_Backup P_((int idx));
static int Fit_WorkPutTo P_((int idx));
static int Fit_Rescale P_((Vfit_t *vp, int idx, int scale));
static int Fit_Setup P_((int idx));
static int Fit_Exec P_((int idx, PVec_t mrk, FitStat_t *fStat, pfi_t suspendFct, pfi_t useFct, pfi_t setupParFct));
static int Fit_Finish P_((int idx));
static int Fit_BgConsistent P_((int idx));
static int Fit_PeakWarn P_((Fit_t fit));
static int Fit_PeakConsistent P_((Fit_t fit));
static int Fit_RegFitExec P_((int idx, int num));
static int Fit_RegFitFinish P_((int num));
static int Fit_IntegrateExec P_((int idx, int num));
static int Fit_IntegrateFinish P_((int num));
static int Fit_VCopy P_((Vfit_t *t, Vfit_t *f));
static int Fit_DeleteFinish P_((int num));
static int Fit_MrkGet P_((int idx));
static int Fit_RecoverExec P_((int idx, int num));
static int Fit_RecoverFinish P_((int num));
static int Fit_CurSetup P_((Cur_t cp, Fit_t fp, Spc_t sp, PVec_t mp));
static int Fit_CurFinish P_((Cur_t cp, Fit_t fp, FitStat_t *fStat));
static int Fit_CheckValid P_((Fit_t fp, int idx));
static int Fit_CopyData P_((Cur_t cp, PVec_t mp, Spc_t sp, double offset, int weightTyp));
static int Fit_CopyDataBg P_((Cur_t cp, Fit_t fp, PVec_t mp, Spc_t sp, double offset, int weightTyp));
static int Fit_ShiftPar P_((Fit_t fp, double offset));
