/* VsMark.c */
extern int Mrk_Check P_((char *name, PVec_t mp));
extern int Mrk_Compress P_((PVec_t mp, char *name));
extern int Mrk_Consistent P_((PVec_t mrk, int maxVal));
extern int Mrk_CursorH P_((void));
extern int Mrk_CursorV P_((void));
extern int Mrk_DeleteVertical P_((void));
extern int Mrk_DeleteHorizontal P_((void));
extern int Mrk_DeleteRcl P_((void));
extern int Mrk_DeleteCut P_((void));
extern int Mrk_DeleteGate P_((void));
extern int Mrk_DeleteBgGate P_((void));
extern int Mrk_DeleteFit P_((void));
extern int Mrk_DeleteFitBg P_((void));
extern int Mrk_DeleteFitReg P_((void));
extern int Mrk_DeleteFitBin P_((void));
extern int Mrk_DeleteFitSea P_((void));
extern int Mrk_DeleteNorm P_((void));
extern int Mrk_Get P_((PVec_t t, Vmrk_t *f, int idx, int scale));
extern int Mrk_Init P_((void));
extern int Mrk_FitRegSingle P_((void));
extern int Mrk_FitRegMultiple P_((void));
extern int Mrk_Precision P_((void));
extern int Mrk_Put P_((Vmrk_t *t, PVec_t f, int idx, int scale));
extern int Mrk_ListVertical P_((void));
extern int Mrk_ListHorizontal P_((void));
extern int Mrk_ListRcl P_((void));
extern int Mrk_ListGate P_((void));
extern int Mrk_ListBgGate P_((void));
extern int Mrk_ListFitBg P_((void));
extern int Mrk_ListFitReg P_((void));
extern int Mrk_ListFitBin P_((void));
extern int Mrk_ListFitSea P_((void));
extern int Mrk_ListNorm P_((void));
extern int Mrk_ReadVertical P_((void));
extern int Mrk_ReadHorizontal P_((void));
extern int Mrk_ReadRcl P_((void));
extern int Mrk_ReadGate P_((void));
extern int Mrk_ReadBgGate P_((void));
extern int Mrk_ReadFitBg P_((void));
extern int Mrk_ReadFitReg P_((void));
extern int Mrk_ReadFitBin P_((void));
extern int Mrk_ReadFitSea P_((void));
extern int Mrk_ReadNorm P_((void));
extern int Mrk_RescalePVec P_((PVec_t pp, Cal_t cal, int scale, char *name));
extern int Mrk_Reset P_((Vmrk_t *vp));
extern int Mrk_RestoreVertical P_((void));
extern int Mrk_RestoreHorizontal P_((void));
extern int Mrk_RestoreRcl P_((void));
extern int Mrk_RestoreGate P_((void));
extern int Mrk_RestoreBgGate P_((void));
extern int Mrk_RestoreFitBg P_((void));
extern int Mrk_RestoreFitReg P_((void));
extern int Mrk_RestoreFitBin P_((void));
extern int Mrk_RestoreFitSea P_((void));
extern int Mrk_RestoreNorm P_((void));
extern int Mrk_EnterVertical P_((void));
extern int Mrk_EnterHorizontal P_((void));
extern int Mrk_EnterRcl P_((void));
extern int Mrk_EnterGate P_((void));
extern int Mrk_EnterBgGate P_((void));
extern int Mrk_EnterCut P_((void));
extern int Mrk_EnterFitBg P_((void));
extern int Mrk_EnterFitReg P_((void));
extern int Mrk_EnterFitBin P_((void));
extern int Mrk_EnterFitSea P_((void));
extern int Mrk_EnterNorm P_((void));
extern int Mrk_EnterRange P_((int dflt_scale, int range_scale, int idx));
extern int Mrk_EnterSingleV P_((int scale, Cal_t cal, double *value, char *pmt));
extern int Mrk_EnterSingleH P_((int scale, double *value, char *pmt));
extern int Mrk_StoreVertical P_((void));
extern int Mrk_StoreHorizontal P_((void));
extern int Mrk_StoreRcl P_((void));
extern int Mrk_StoreGate P_((void));
extern int Mrk_StoreBgGate P_((void));
extern int Mrk_StoreFitBg P_((void));
extern int Mrk_StoreFitReg P_((void));
extern int Mrk_StoreFitBin P_((void));
extern int Mrk_StoreFitSea P_((void));
extern int Mrk_StoreNorm P_((void));
extern int Mrk_ScaleCut P_((void));
extern int Mrk_ScaleFit P_((void));
extern int Mrk_ScaleFitSea P_((void));
extern int Mrk_ScaleNorm P_((void));
extern int Mrk_UnitCalib P_((void));
extern int Mrk_UnitUncalib P_((void));
extern int Mrk_ValueRead P_((int scale, Cal_t cal, double *value, char *name));
extern int Mrk_ValueReadOffset P_((int scale, Cal_t cal, double *value, char *name));
extern int Mrk_WorkDelete P_((void));
extern int Mrk_WorkReadH P_((void));
extern int Mrk_WorkReadV P_((void));
extern int Mrk_WorkReadVOffset P_((void));
extern int Mrk_WorkReset P_((void));
extern int Mrk_WriteVertical P_((void));
extern int Mrk_WriteHorizontal P_((void));
extern int Mrk_WriteRcl P_((void));
extern int Mrk_WriteGate P_((void));
extern int Mrk_WriteBgGate P_((void));
extern int Mrk_WriteFitBg P_((void));
extern int Mrk_WriteFitReg P_((void));
extern int Mrk_WriteFitBin P_((void));
extern int Mrk_WriteFitSea P_((void));
extern int Mrk_WriteNorm P_((void));
