/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawFit.h,v 1.2 1994/05/26 19:48:55 vs Exp vs $ */

#ifndef _DrawFit_h
#define _DrawFit_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef enum {
  GowRegionFit,
  GowBgFit
} GowFitType;

typedef struct {
  int gc_idx;
  Cal_t cal;
  Fit_t fit;
  int (*fct_setup)();
  int (*fct_finish)();
  double (*fct)();
  double *norm;
  GowFitType typ;
} DrawFitRec, *DrawFit_t;

#define DrawFitGCIdx(p)		((p)->gc_idx)
#define DrawFitCal(p)		((p)->cal)
#define DrawFitFit(p)		((p)->fit)
#define DrawFitFctSetup(p)	((p)->fct_setup)
#define DrawFitFctFinish(p)	((p)->fct_finish)
#define DrawFitFct(p)		((p)->fct)
#define DrawFitTyp(p)		((p)->typ)
#define DrawFitNorm(p)		((p)->norm)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawFit P_((GowDestination dest, DrawFit_t dfit,
			   GowScale x_scale, GowScale y_scale,
			   int step_width, int min_steps,
			   int calibrated,
			   GowScaleModificationType modification,
			   int normalized));
extern void DrawFitExpand P_((DrawFit_t dfit,
			      GowScale x_scale, GowScaleType x_type,
			      int x_full,
			      GowScale y_scale, GowScaleType y_type,
			      int y_full,
			      int calibrated,
			      GowScaleModificationType modification,
			      int normalized));
#undef P_

#endif				/* _DrawFit_h */
