/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawPeakList.h,v 1.2 1994/05/26 19:48:59 vs Exp vs $ */

#ifndef _DrawPeakList_h
#define _DrawPeakList_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>
#include <Gow/DrawPeak.h>

typedef struct {
  Fio_t fio;
  DrawPeakRec peak;
} DrawPeakListRec, *DrawPeakList_t;

#define DrawPeakListPeak(p)	(&(p)->peak)
#define DrawPeakListFio(p)	((p)->fio)

#define DrawPeakListGCPos(p)	DrawPeakGCPos(DrawPeakListPeak(p))
#define DrawPeakListGCNeg(p)	DrawPeakGCNeg(DrawPeakListPeak(p))
#define DrawPeakListCal(p)	DrawPeakCal(DrawPeakListPeak(p))
#define DrawPeakListNorm(p)	DrawPeakNorm(DrawPeakListPeak(p))

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawPeakList P_((GowDestination dest, DrawPeakList_t dpeaks,
				GowScale x_scale, GowScale y_scale,
				int step_width, int min_steps,
				int calibrated,
				GowScaleModificationType modification,
				int normalized));
extern void DrawPeakListExpand P_((DrawPeakList_t dpeaks,
				   GowScale x_scale, GowScaleType x_type,
				   int x_full,
				   GowScale y_scale, GowScaleType y_type,
				   int y_full,
				   int calibrated,
				   GowScaleModificationType modification,
				   int normalized));
#undef P_

#endif				/* _DrawPeakList_h */
