/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/DrawVMark.h,v 1.2 1994/05/26 19:49:02 vs Exp vs $ */

#ifndef _DrawVMark_h
#define _DrawVMark_h

#include <tv/vsTypes.h>
#include <Gow/GowConfig.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>

typedef enum {
  DrawTopBar,
  DrawBottomBar,
  DrawNoBar
  } DrawVBarPosition;

typedef struct {
  int gc_idx;
  PVec_t mrk;
  Val_t sgl;
  DVecRec vis;
  PVecRec bar;
  Cal_t cal;
  Boolean calibrated;
} DrawVMrkRec, *DrawVMrk_t;

#define DrawVMrkGCIdx(p)	((p)->gc_idx)
#define DrawVMrkMrk(p)		((p)->mrk)
#define DrawVMrkSgl(p)		((p)->sgl)
#define DrawVMrkVis(p)		(&(p)->vis)
#define DrawVMrkBar(p)		(&(p)->bar)
#define DrawVMrkCal(p)		((p)->cal)
#define DrawVMrkCalibrated(p)	((p)->calibrated)

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

extern Boolean DrawVMark P_((GowDestination dest, DrawVMrk_t dmrk,
			     GowScale x_scale, GowScale y_scale,
			     double bot_frac, double top_frac, double cross,
			     int bar_position,
			     int calibrated));
extern void DrawVMarkFree P_((DrawVMrk_t dmrk));
extern void DrawVMarkInit P_((DrawVMrk_t dmrk));
#undef P_

#endif				/* _DrawVMark_h */
