/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowCutWidget.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowCutWidget_h
#define _GowCutWidget_h

#include <X11/Constraint.h>
#include <X11/Xmu/Converters.h>
#include <X11/Xfuncproto.h>

#include <Gow/GowConfig.h>
#include <Gow/GowDest.h>

/****************************************************************
 *
 * Vertical Paned Widget (SubClass of CompositeClass)
 *
 ****************************************************************/

/* RESOURCES:

 Name		         Class		   RepType	    Default Value
 ----		         -----		   -------	    -------------
 adjustCursor	         Cursor	           Cursor	    **
 cursor		         Cursor	           Cursor	    None
 gripCursor	         Cursor	           Cursor	    **
 heightRatio		 HeightRatio	   Float	    0.3
 widthToHeight		 WidthToHeight	   Float	    1.2
 internalBorderWidth     BorderWidth	   Position	    1

*/

/* New Fields */
#define XtNheightRatio		"heightRatio"
#define XtNwidthToHeight	"widthToHeight"
#ifndef XtNgripCursor
#define XtNgripCursor		"gripCursor"
#endif
#ifndef XtNinternalBorderWidth
#define XtNinternalBorderWidth	"internalBorderWidth"
#endif
#define XtNadjustCursor		"adjustCursor"

#define XtCHeightRatio		"HeightRatio"
#define XtCWidthToHeight	"WidthToHeight"

#define XtCMin "Min"
#define XtCMax "Max"
#define XtCPreferredPaneSize "PreferredPaneSize"
#define XtCShowGrip "ShowGrip"

/* Class record constant */
extern WidgetClass gowCutWidgetClass;

typedef struct _GowCutWidgetClassRec	*GowCutWidgetClass;
typedef struct _GowCutWidgetRec		*GowCutWidget;

/************************************************************
 *
 *  Public Procedures 
 *
 ************************************************************/

_XFUNCPROTOBEGIN

extern void GowCutWidgetPlot(
#if NeedFunctionPrototypes
     Widget			/* w */,
     GowDestFile		/* fp */,
     int			/* type */,
     GowDestGeometry		/* geo */
#endif
);

_XFUNCPROTOEND

#endif /* _GowCutWidget_h */
/* DON'T ADD STUFF AFTER THIS #endif */
