/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowCutWidgetP.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowCutWidgetP_h
#define _GowCutWidgetP_h

#include <Gow/GowCutWidget.h>

/*********************************************************************
 *
 * Paned Widget Private Data
 *
 *********************************************************************/

/* New fields for the GowCutWidget widget class record */

typedef struct _GowCutWidgetClassPart {
    int foo;			/* keep compiler happy. */
} GowCutWidgetClassPart;

/* Full Class record declaration */
typedef struct _GowCutWidgetClassRec {
    CoreClassPart       core_class;
    CompositeClassPart  composite_class;
    GowCutWidgetClassPart     cut_widget_class;
} GowCutWidgetClassRec;

extern GowCutWidgetClassRec gowCutWidgetClassRec;

/* New Fields for the GowCutWidget widget record */
typedef struct {
    /* resources */
  
  XtTranslations grip_translations; /* grip translation table */
  Dimension	internal_bw;	/* internal border width. */
  float		height_ratio;	/* height ratio of minor window to cutwindow */
  float		width_to_height; /* width to height ratio of minor window */

  Cursor	cursor;		/* Cursor for paned window */
  Cursor	grip_cursor;	/* inactive grip cursor */
  Cursor	adjust_cursor;	/* active grip cursor: T */

  /* private */
  Widget	grip;
  int		x_offset;	/* mouse origin when adjusting */
  int		y_offset;	/* mouse origin when adjusting */
  GC		flipgc;		/* GC to use when animating
				   borders */
  XSegment	track_lines[2];
  Boolean	grip_adjust;
} GowCutWidgetPart;

/**************************************************************************
 *
 * Full instance record declaration
 *
 **************************************************************************/

typedef struct _GowCutWidgetRec {
    CorePart       core;
    CompositePart  composite;
    GowCutWidgetPart     cut_widget;
} GowCutWidgetRec;

#endif /* _GowCutWidgetP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
