/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowDestWidgetP.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowDestWidgetP_h
#define _GowDestWidgetP_h

#include <Gow/GowDestWidget.h>

/****************************************************************
 *
 * GowDestWidget widget private
 *
 ****************************************************************/

#define DEFAULT_WIDTH  1024   /* take Tek screen width as default */
#define DEFAULT_HEIGHT  780   /* take Tek screen height as default */

typedef struct _GowDestinationWidgetClassRec {
  CoreClassPart		core_class;
  CompositeClassPart	composite_class;
} GowDestinationWidgetClassRec;

extern GowDestinationWidgetClassRec gowDestinationWidgetClassRec;

typedef struct _GowDestinationWidgetPart {

  /* resources */

  int		backing_store;	/* What type of backing store to use. */
  Cursor	cursor;		/* The standard cursor. */

  /* private state */

  GowDestination destination;	/* standard interface for drawing */

} GowDestinationWidgetPart;

typedef struct _GowDestinationWidgetRec {
  CorePart			core;
  CompositePart 		composite;
  GowDestinationWidgetPart      destination_widget;
} GowDestinationWidgetRec;

/************************************************************
 *
 * Private declarations.
 *
 ************************************************************/

#endif /* _GowDestWidgetP_h */
