/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowFramWidgetP.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowFramWidgetP_h
#define _GowFramWidgetP_h

#include <Gow/GowDestWidgetP.h>
#include <Gow/GowFramWidget.h>
#include <Gow/DrawAxis.h>
#include <Gow/GowGCs.h>

/*********************************************************************
 *
 * Paned Widget Private Data
 *
 *********************************************************************/

/* New fields for the GowFrameWidget widget class record */

typedef struct _GowFrameWidgetClassPart {
    int foo;			/* keep compiler happy. */
} GowFrameWidgetClassPart;

/* Full Class record declaration */
typedef struct _GowFrameWidgetClassRec {
    CoreClassPart       core_class;
    CompositeClassPart  composite_class;
    GowFrameWidgetClassPart     frame_widget_class;
} GowFrameWidgetClassRec;

extern GowFrameWidgetClassRec gowFrameWidgetClassRec;

/* New Fields for the GowFrameWidget widget record */
typedef struct {
    /* resources */
  
  float		tic[TIC_NUM];
  DrawAxis_t	axis[AXIS_NUM];
  int		frame[AXIS_NUM];

  /* private */

  GowDestGCs	gcs;
  Boolean	visible[AXIS_NUM];
  Boolean	needs_redisplay;
  int		frame_px[AXIS_NUM];
  int		plot_x;
  int		plot_y;
  int		plot_width;
  int		plot_height;
} GowFrameWidgetPart;

/**************************************************************************
 *
 * Full instance record declaration
 *
 **************************************************************************/

typedef struct _GowFrameWidgetRec {
    CorePart		core;
    CompositePart	composite;
    GowDestinationWidgetPart destination_widget;
    GowFrameWidgetPart	frame_widget;
} GowFrameWidgetRec;

#endif /* _GowFramWidgetP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
