/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/Gow/RCS/GowLabelP.h,v 1.2 1994/05/26 19:49:23 vs Exp vs $ */

#ifndef _GowLabelP_h
#define _GowLabelP_h

#include <Gow/GowMarkP.h>
#include <Gow/GowLabel.h>

extern GowObjectClassRec gowLabelObjectClassRec;

typedef struct _GowLabelObjectPart {
				/* resources */
  float		label_distance;
  float		label_line;
  float		library_radius;
  int		channel_radius;
  Boolean	top_spectrum;
} GowLabelObjectPart;

typedef struct _GowLabelObjectRec {
  ObjectPart		object;
  RectObjPart		rectangle;
  GowObjectPart		gow_object;
  GowMarkObjectPart	gow_mark;
  GowLabelObjectPart	gow_label;
} GowLabelObjectRec;

/************************************************************
 *
 * Private declarations.
 *
 ************************************************************/

#endif /* _GowLabelP_h */
