/* $Header: /usr/files/home/Gamma/vs/tv/edit/Gow/RCS/GowVsWidgetP.h,v 1.1 1993/09/17 14:56:03 vs Exp vs $ */

#ifndef _GowVsWidgetP_h
#define _GowVsWidgetP_h

#include <Gow/GowWidgetP.h>
#include <Gow/GowVsWidget.h>

/****************************************************************
 *
 * GowVsWidget widget private
 *
 ****************************************************************/

extern GowWidgetClassRec gowVsWidgetClassRec;

typedef struct _GowVsWidgetPart {

  /* resources */

  Boolean	x_scale_calibrated;
  Boolean	spectra_normalized;
  GowScaleModificationType y_scale_modification;
  /* private state */

} GowVsWidgetPart;

typedef struct _GowVsWidgetRec {
  CorePart			core;
  CompositePart 		composite;
  GowDestinationWidgetPart	destination_widget;
  GowWidgetPart			gow_widget;
  GowVsWidgetPart		vs_widget;
} GowVsWidgetRec;

#define XtRScaleModification		"ScaleModification"

#endif /* _GowVsWidgetP_h */
