/* vsCal.c */
extern char *CalError P_((int err_no));
extern int CalInit P_((Cal_t c));
extern int CalFree P_((Cal_t c));
extern int CalDelete P_((int typ, Cal_t c));
extern int CalRead P_((int typ, Cal_t c, char *file));
extern int CalWrite P_((int typ, Cal_t c, char *file));
extern int CalCopy P_((int typ, Cal_t to, Cal_t from));
extern int CalExists P_((int typ, Cal_t c));
extern int CalCheck P_((int typ, Cal_t c));
extern int CalEqual P_((int typ, Cal_t c1, Cal_t c2));
extern double CalP P_((Cal_t cp, double channel));
extern double CalUnity P_((Cal_t cp, double x));
extern double CalId P_((Cal_t cp, double x));
extern double CalS P_((Cal_t cp, double channel));
extern double CalW P_((Cal_t cp, double channel));
extern double CalTl P_((Cal_t cp, double channel));
extern double CalTr P_((Cal_t cp, double channel));
extern double CalSh P_((Cal_t cp, double channel));
extern double CalSw P_((Cal_t cp, double channel));
extern double CalC P_((Cal_t cp, double position));
extern double CalVc P_((Cal_t cp));
extern double CalStart P_((Cal_t cp));
extern double CalEfc P_((Cal_t cp, double channel));
extern double CalEfcP P_((Cal_t cp, double position));
extern char *CalUnit P_((Cal_t cp));
extern char *CalChn P_((Cal_t cp));
extern double CalCWidth P_((Cal_t cp, double pos, double w_pos));
extern double CalCDwidth P_((Cal_t cp, double pos, double w_pos, double dw_pos));
extern double CalPWidth P_((Cal_t cp, double chn, double w_chn));
extern double CalPDwidth P_((Cal_t cp, double chn, double w_chn, double dw_chn));
