/* vsCal.c */
static void CalDelPos P_((Cal_t c));
static void CalDelWidth P_((Cal_t c));
static void CalDelTl P_((Cal_t c));
static void CalDelTr P_((Cal_t c));
static void CalDelSh P_((Cal_t c));
static void CalDelSw P_((Cal_t c));
static void CalDelVc P_((Cal_t c));
static void CalDelStart P_((Cal_t c));
static void CalDelEfc P_((Cal_t c));
static void CalDelUnit P_((Cal_t c));
static int CpyCoef P_((Coef_t *to, Coef_t *from));
static int ReadCoef P_((FILE *fp, Coef_t *c));
static int ReadCoefCal P_((FILE *fp, char *file, char *keyword, CoefCal_t *cal));
static int CpyCons P_((Cons_t *to, Cons_t *from));
static int ReadCons P_((FILE *fp, Cons_t *c));
static int ReadConsCal P_((FILE *fp, char *file, char *keyword, ConsCal_t *cal));
static int CpyEfc P_((Efc_t *to, Efc_t *from));
static int ReadEfc P_((FILE *fp, Efc_t *c));
static int ReadEfcCal P_((FILE *fp, char *file, char *keyword, EfcCal_t *cal));
static int CpyStr P_((char *to, char *from));
static int ReadStr P_((FILE *fp, char *s));
static int ReadStrCal P_((FILE *fp, char *file, char *keyword, StrCal_t *cal));
static int FindKeyword P_((FILE *fp, char *keyword));
static int WriteCoef P_((FILE *fp, Coef_t *c));
static int WriteCoefCal P_((FILE *fp, char *file, char *keyword, CoefCal_t *cal));
static int WriteCons P_((FILE *fp, Cons_t *c));
static int WriteConsCal P_((FILE *fp, char *file, char *keyword, ConsCal_t *cal));
static int WriteStr P_((FILE *fp, char *c));
static int WriteStrCal P_((FILE *fp, char *file, char *keyword, StrCal_t *cal));
static int WriteEfc P_((FILE *fp, Efc_t *c));
static int WriteEfcCal P_((FILE *fp, char *file, char *keyword, EfcCal_t *cal));
static int CopyCoefCal P_((CoefCal_t *to, CoefCal_t *from));
static int CopyConsCal P_((ConsCal_t *to, ConsCal_t *from));
static int CopyEfcCal P_((EfcCal_t *to, EfcCal_t *from));
static int CopyStrCal P_((StrCal_t *to, StrCal_t *from));
static double CalP0 P_((Cal_t cp, double channel));
