/* $Header: /usr/files/home/Gamma/vs/tv/edit/lib/tv/RCS/vsConfig.h,v 1.3 1994/09/20 14:47:41 vs Exp vs $ */
#ifndef _vsConfig_h
#define _vsConfig_h

/*
 *  Ultrix 
 */

#ifdef ultrix
# define OPERATING_SYSTEM "Ultrix"
#endif
/*
 *  LinuX 
 */

#ifdef linux
# define OPERATING_SYSTEM "Linux"
#endif

/*
 *  SunOS
 */

#ifdef sun
# define OPERATING_SYSTEM "SunOS"
				/* some undefined externals */
#include <time.h>

#if 0
extern int	fwrite();
extern		rewind();
extern char	*vsprintf();
extern int	fread();
extern int	fprintf();
extern int	fscanf();
extern int	sscanf();
extern char	*memset();
#endif

extern		fclose();
extern		fflush();
extern int	fgetc();
extern int	fputc();
extern		fputs();
extern		fseek();
extern		pclose();
extern time_t	time();
extern int 	toupper();
#endif

/*
 *  HP-UX
 */

#ifdef hpux
# define OPERATING_SYSTEM "HP-UX"
#endif

/*
 *  LynxOS
 */

#ifdef Lynx
# define OPERATING_SYSTEM "LynxOS"
#define isnan(x)                (0)
#endif

/*
 * Unknown operating system
 */

#ifndef OPERATING_SYSTEM
#define OPERATING_SYSTEM "Operating system undefined"
				/* no restrictions known */
#endif

/*
 * no restrictions
 */

#ifndef strerror
extern char *strerror();
#endif
#ifdef HAVE_ALLOCA
#ifdef HAVE_ALLOCA_H /* Need header file for alloca() */
#include <alloca.h>
#endif /*HAVE_ALLOCA_H */

# define StackAlloc(typ,p,size,maxsize)	*p= (typ*)alloca(size * sizeof(typ))
#else
# define StackAlloc(typ,p,size,maxsize)		p[maxsize]
#endif /* HAVE_ALLOCA */

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#ifndef HAS_EXP10
#define exp10(x)		pow(10.0,x)
#else
extern double exp10();
#endif

#ifndef HAS_MEMMOVE
extern void *memmove P_((void *t, void *f, size_t len));
#endif

#ifndef HAS_STRCHR
extern char *strchr P_((char *s, int c));
#endif

#undef P_

#endif				/* vsConfig.h */
