/* vsCurFit.c */
static int CurCheck P_((Cur_t cp));
static double CurChiSqr P_((Cur_t cp, Par_t pp));
static double CurPoissonLikelihood P_((Cur_t cp, Par_t pp));
static int CurEvalCurvature P_((Cur_t cp, double *alpha, double *oldBeta, double *oldDiag));
static int CurSolveSymmetric P_((double *a, double *b, int order));
static int CurInverseSymmetric P_((double *a, double *b, int order));
static int CurFinish P_((Cur_t cp, double *oldBeta, double *beta, double *oldDiag));
static int CurNumericDerivation P_((double x, double *grad));
static int CurNumericDerivationOk P_((void));
