/* vsFitIo_new.c */
static int FioTailWrite P_((Fio_t fp));
static int FioTailFinish P_((Fio_t fp));
static int FioTailReadVec P_((RFILE *rfp, int recTyp, pfi_t read_fct, Vec_t vec));
static int FioTailWriteVec P_((RFILE *rfp, int recTyp, pfi_t write_fct, Vec_t vec));
static int FioUpdateToc P_((Fio_t fp, unsigned int pos, Fit_t ftp, int *idx));
static int FioUpdateBin P_((Fio_t fp, Pair_t *binMarks, Fit_t ftp, int tocIdx));
static int FioBinInsert P_((Fio_t fp, int idx, Pair_t *binMarks, Fit_t ftp, int tocIdx));
static int FioBinSub P_((Fio_t fp, int idx));
static int FioBinAdd P_((Fio_t fp, int idx, Pair_t *binMarks, int tocIdx));
static int FioBinSplit P_((Fio_t fp, int idx, Pair_t *binMarks));
static int FioPeakDecIdx P_((Fio_t fp, double limit));
static int FioPeakIncIdx P_((Fio_t fp, double limit));
static int FioPeakDel P_((Fio_t fp, Pair_t *binMarks));
static int FioPeakInsert P_((Fio_t fp, int idx, Pair_t *binMarks, Fit_t ftp));
static int Fit_w P_((RFILE *rfp, Fit_t fp));
static int Fit_r P_((RFILE *rfp, Fit_t fp));
static int FitB_w P_((RFILE *rfp, Fit_t fp));
static int FitB_r P_((RFILE *rfp, Fit_t fp));
static int FitStat_w P_((RFILE *rfp, FitStat_t *fp));
static int FitStat_r P_((RFILE *rfp, FitStat_t *fp));
static int FitInt_w P_((RFILE *rfp, FitInt_t *fip));
static int FitInt_r P_((RFILE *rfp, FitInt_t *fip));
static int Vec_w P_((RFILE *rfp, pfi_t write_fct, Vec_t vp));
static int Vec_r P_((RFILE *rfp, pfi_t read_fct, Vec_t vp));
static int doubleP_w P_((RFILE *rfp, double *p));
static int doubleP_r P_((RFILE *rfp, double *p));
static int ParV_w P_((RFILE *rfp, ParV_t *pvp));
static int ParV_r P_((RFILE *rfp, ParV_t *pvp));
static int FioWriteFitPar P_((RFILE *rfp, Fit_t fp));
static int FioReadFitPar P_((RFILE *rfp, Fit_t fp));
static int Pair_w P_((RFILE *rfp, Pair_t *p));
static int Pair_r P_((RFILE *rfp, Pair_t *p));
static int FioTailWriteSeaPeakList P_((Fio_t fp, int recTyp));
static int FioTailReadSeaPeakList P_((Fio_t fp, int recTyp));
static int SeaPeak_w P_((RFILE *rfp, SeaPeak p));
static int SeaPeak_r P_((RFILE *rfp, SeaPeak p));
static int FioToc_w P_((RFILE *rfp, FioToc_t *p));
static int FioToc_r P_((RFILE *rfp, FioToc_t *p));
static int Bin_w P_((RFILE *rfp, Bin_t *p));
static int Bin_r P_((RFILE *rfp, Bin_t *p));
static int FioPea_w P_((RFILE *rfp, FioPea_t *p));
static int FioPea_r P_((RFILE *rfp, FioPea_t *p));
