/* vsFit.c */
static int FitDisablePars P_((Fit_t fp, int userTyp));
static int FitOptInit P_((Fit_t fp));
static double FitDBg2Polynom P_((Fit_t fp, double x));
static int BgDerivation P_((Fit_t fp, double *grd, double x));
static int CAFunctionSetup P_((Fit_t fp, Par_t pp));
static int CAFunctionFinish P_((Fit_t fp));
static FitOptCA CAPeakFunctionSetup P_((FitOptCA vp, Fit_t fp, Par_t pp, int peakIdx));
static FitOptCA CAPeakFunctionFinish P_((FitOptCA op));
static int CADerivationSetup P_((Fit_t fp, Par_t pp));
static int CADerivationFinish P_((Fit_t fp));
static int CADerivation P_((Fit_t fp, double x, double *grad));
static int CAUnitPeakDerivation P_((FitOptCA op, double x, double x0, double *fct_val, double *grad_x0));
static double CAFunction P_((Fit_t fp, double x));
static double CANormVolume P_((FitOptCA pre));
static double CAStepFunction P_((Fit_t fp, double x));
static double CAPeakFunction P_((FitOptCA pre, double x));
static double CAUnitPeakFunction P_((FitOptCA op, double x, double x0));
static int AEFunctionSetup P_((Fit_t fp, Par_t pp));
static int AEFunctionFinish P_((Fit_t fp));
static FitOptAE AEPeakFunctionSetup P_((FitOptAE vp, Fit_t fp, Par_t pp, int peakIdx));
static FitOptAE AEPeakFunctionFinish P_((FitOptAE op));
static int AEDerivationSetup P_((Fit_t fp, Par_t pp));
static int AEDerivationFinish P_((Fit_t fp));
static int AEDerivation P_((Fit_t fp, double x, double *grad));
static int AEUnitPeakDerivation P_((FitOptAE op, double x, double x0, double *fct_val, double *grad_x0));
static double AEFunction P_((Fit_t fp, double x));
static double AENormVolume P_((FitOptAE pre));
static double AEStepFunction P_((Fit_t fp, double x));
static double AEPeakFunction P_((FitOptAE op, double x));
static double AEUnitPeakFunction P_((FitOptAE op, double x, double x0));
