/* vsRecord.c */
static int ReadStart P_((RFil_t *rtp, unsigned int pos));
static int ReadFinish P_((RFil_t *rtp));
static int RecTocIdx P_((RFil_t *rtp, int typ));
static int WriteStart P_((RFil_t *rtp, int typ, unsigned int startPos));
static int WriteFinish P_((RFil_t *rtp));
static int RecUpdateToc P_((RFil_t *rtp, unsigned int pos, int typ));
static int RecWriteMode P_((RFILE *rfp));
static int RecLocked P_((RFILE *rfp));
static int RecWriteHead P_((RFil_t *rtp));
static int RecReadHead P_((RFil_t *rtp));
static int RecWriteToc P_((RFil_t *rtp));
static int RecReadToc P_((RFil_t *rtp));
static int RecBackup P_((RFILE *rfp));
static int RecBackupFile P_((char *t, char *f, char *expr));
static int RecBackupIntern P_((RFILE *rfp));
static int RecTailCopy P_((RFil_t *t, RFil_t *f));
static int RecFInit P_((RFILE *rfp));
static int RecFilInit P_((RFil_t *rtp));
static int RecFilReset P_((RFil_t *rtp));
static int RecTailReset P_((RFil_t *rtp, unsigned int pos));
static int RecTocRealloc P_((RFil_t *rtp, int num));
static int RecFilFree P_((RFil_t *rtp));
static int WriteChars P_((RFil_t *rtp, char *c, unsigned int num));
static int ReadChars P_((RFil_t *rtp, char *c, unsigned int num));
static int WriteInt2 P_((RFil_t *rtp, int i));
static int ReadInt2 P_((RFil_t *rtp, short *i));
static int WriteUInt2 P_((RFil_t *rtp, int i));
static int ReadUInt2 P_((RFil_t *rtp, unsigned short *i));
static int WriteInt4 P_((RFil_t *rtp, int i));
static int ReadInt4 P_((RFil_t *rtp, int *i));
static int WriteUInt4 P_((RFil_t *rtp, unsigned int i));
static int ReadUInt4 P_((RFil_t *rtp, unsigned int *i));
static int WriteFloat4 P_((RFil_t *rtp, double f));
static int ReadFloat4 P_((RFil_t *rtp, float *f));
