/* vsSpectra.c */
extern char *SpcError P_((int err_no));
extern SpcFile_t SpcOpen P_((char *file, char *format, char *mode));
extern int SpcClose P_((SpcFile_t sfp));
extern int SpcAlloc P_((Spc_t sp, int siz));
extern int SpcRealloc P_((Spc_t sp, int siz));
extern int SpcFree P_((Spc_t sp));
extern int SpcInit P_((Spc_t sp, int typ));
extern int SpcShmInit P_((Spc_t sp, int typ));
extern int SpcReset P_((Spc_t sp));
extern int SpcClear P_((Spc_t sp));
extern int SpcCopy P_((Spc_t t, Spc_t f));
extern int SpcAdd P_((Spc_t t, Spc_t f, Cal_t, Cal_t));
extern int SpcIntegrate P_((Spc_t sp, double x1, double x2, double *sum, double *dSum));
extern int SpcIntegratePVec P_((Spc_t sp, PVec_t pp, double *sum, double *dSum));
extern int SpcProject P_((SpcFile_t sfp, double x1, double x2, Spc_t sp));
extern int SpcSub P_((Spc_t t, Spc_t f, Cal_t, Cal_t));
extern int SpcMin P_((Spc_t t, Spc_t f, Cal_t, Cal_t));
extern int SpcMax P_((Spc_t t, Spc_t f, Cal_t, Cal_t));
extern int SpcMultiply P_((Spc_t sp, double fac));
extern int SpcOffset P_((Spc_t sp, double offset));
extern int SpcRead P_((Spc_t sp, char *file, char *format));
extern int SpcReadLine P_((Spc_t sp, SpcFile_t sfp, int line));
extern int SpcReadAdd P_((Spc_t sp, char *file, char *format));
extern int SpcReadAddLine P_((Spc_t sp, SpcFile_t sfp, int line));
extern int SpcReadSub P_((Spc_t sp, char *file, char *format));
extern int SpcReadSubLine P_((Spc_t sp, SpcFile_t sfp, int line));
extern int SpcSet P_((Spc_t sp, int typ, size_t typSiz, char *buffer, int spcLen));
extern int SpcSetInfo P_((SpcFile_t sfp, minfo *mip));
extern int SpcWrite P_((Spc_t sp, char *file, char *format));
extern int SpcGetBestInfo P_((Spc_t sp, minfo *actInfo, minfo *bestInfo));
extern int SpcGetInfo P_((SpcFile_t sfp, minfo *mip));
extern int SpcWriteLine P_((Spc_t sp, SpcFile_t sfp, int line));
