/* vsUserFace.c */

#if defined(__cplusplus)
extern "C" int UFBufferSet P_((UF_t *up, char *buffer));
#else
extern int UFBufferSet P_((UF_t *up, char *buffer));
#endif
extern int UFClose P_((UF_t *up));
extern char *UFError P_((int err_no));
extern int UFExecuteShell P_((UF_t *up));
extern int UFFileClose P_((UF_t *up));
extern int UFFileCloseCmd P_((UF_t *up));
extern int UFFileCloseOut P_((UF_t *up));
extern int UFFileOpen P_((UF_t *up, char *file, int protocol, int autoEof));
extern int UFFileResume P_((UF_t *up));
extern int UFFileOpenCmd P_((UF_t *up, char *name, char *mode));
extern int UFFileOpenOut P_((UF_t *up, char *name, char *mode));
extern int UFFileSuspend P_((UF_t *up));
extern int UFIntGet P_((UF_t *up, char **bp, int unexpected, int *number));
extern int UFItemGet P_((UF_t *up, char **bp, char *buffer, int bufLen));
extern int UFQuoteChar P_((int src, char **dst, int *dlen, int quote));
extern int UFUnquoteChar P_((char **src, char **dst, int *dlen, int quote));
extern int UFItemGetV P_((UF_t *up, char **bp, char *buffer, int bufLen));
extern char *UFItemSPrint P_((char *item, char *buffer, int bufLen, int quote));
extern int UFItemTest P_((UF_t *up, int unexpected));
extern int UFItemTestString P_((UF_t *up, char *b, int unexpected));
extern int UFMenuLoop P_((UF_t *up, Men_t *startMenu, char *prompt));
extern int UFMenuLoopFile P_((UF_t *up, char *file, Men_t *menu, char *prompt));
extern int UFMenuLoopContinue P_((void));
extern int UFMenuLoopExit P_((UF_t *up));
extern int UFMenuLoopExitQBreak P_((UF_t *up));
extern int UFRootLoopQBreak P_((UF_t *up));
extern int UFMenuLoopLoop P_((UF_t *up));
extern int UFMenuLoopSingle P_((UF_t *up));
extern int UFNoArgs P_((UF_t *up));
extern UF_t *UFOpen P_((int bufSiz, int bufNum, int filNum, int menNum, pfv_t inputLoopFct, pfi_t printFct, pfi_t printPagedFct, void *printStdOut, void *printStdErr, char *path));
extern char *UFPrompt P_((UF_t *up));
extern int UFRealGet P_((UF_t *up, char **bp, int unexpected, double *number, double *precision));
extern int UFReset P_((UF_t *up));
extern int UFResetIllegal P_((UF_t *up));
extern void UFSimpleInit P_((UF_t *up));
extern int UFSkipEmpty P_((UF_t *up));
extern int UFSkipTo P_((UF_t *up, char *s));
extern char *UFSkipToTest P_((UF_t *up, char *b, char *s));
extern int UFStopTyp P_((UF_t *up));
extern int UFUpdateQueueBreak P_((UF_t *up));

extern int Offer_UDP_Service P_(( ));
extern int Enter_ServerMode P_(());
extern int Leave_ServerMode P_(());
extern char* net_readline P_((char* prompt));
