/* VdLabel.c */
static int CutCalib P_((int on));
static int FitCalib P_((int on));
static int PeaklistCalib P_((int on));
static int UserCalib P_((int on));
static int LabelCalib P_((GowLabel gl, int on));
static int CutUncalib P_((int on));
static int FitUncalib P_((int on));
static int PeaklistUncalib P_((int on));
static int UserUncalib P_((int on));
static int LabelUncalib P_((GowLabel gl, int on));
static int CutString P_((int on));
static int FitString P_((int on));
static int PeaklistString P_((int on));
static int UserString P_((int on));
static int LabelString P_((GowLabel gl, int on));
static void PrintLabelParam P_((DrawLbl_t d));
static int LabelLibrary P_((GowLabel gl));
static VdLabellist GetLabellist P_((char *title));
static Labellist_t CreateLabellist P_((char *title, char *path));
static void DeleteLabels P_((Labellist_t labellist));
static Labellist_t DestroyLabellist P_((Labellist_t labellist));
static int InsertLabellist P_((Labellist_t ll));
static void *NextLabel P_((void *dlbl, void *l));
static void *PrevLabel P_((void *dlbl, void *l));
static int LabelGC P_((void *dlbl, void *l));
static double LabelPos P_((void *dlbl, void *l));
static char *LabelTxt P_((void *dlbl, void *l));
static Boolean LabelCalibrated P_((void *dlbl));
static void UseLabellist P_((VdSetup setup, Labellist_t ll));
static void UseLibrary P_((GowLabel gl, void *lib));
static void UseNotLibrary P_((GowLabel gl, void *lib));
static int ReadFile P_((int merge));
static int ReadLabellist P_((char *title, char *file, int merge));
static int InsertLabel P_((Labellist_t labellist, double x, int gc, char *txt));
static int InsertLabelSilent P_((Labellist_t labellist, double x, int gc, char *txt));
static void DeleteLabelIdx P_((Labellist_t labellist, int idx));
static int WriteLabellist P_((Labellist_t labellist, char *file));
static int WriteDrawLabel P_((DrawLbl_t dlbl, char *file));
static void ChangedLabellist P_((Labellist_t labellist));
static int ReplaceLabellist P_((VdLabellist vll, Labellist_t ll));
static int ReadTitle P_((char *title, char *file));
