/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdMain.c,v 1.2 1994/05/26 19:51:20 vs Exp vs $ */

#define _VdMain_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <tv/vsTypes.h>
#include <Gow/GowDest.h>
#include <Gow/GowScale.h>
#include <Gow/GowVsWidget.h>
#include <Gow/GowObject.h>

#include "VsUserFace.h"
#include "VsActiv.h"
#include "VsError.h"

#include "VdWidget.h"
#include "VdNotify.h"
#include "VdResid.h"

#include "VdMain.h"
#include "VdMainP.h"
/* ---------------------------------------------------------------------- */
int VdShowAct()
{
  VdSetup setup;
  ForAllSetups(setup) {
    if (setup->dspc) { Act_Show(setup->act); } }
  return TRUE; 
}
/* ---------------------------------------------------------------------- */
int VdShowShells()
{
  VdSetup setup;
  ForAllSetups(setup) {
    char name[IOBUFLEN];

    sprintf(name, "%s.%s:", XtName(setup->shell), XtName(setup->frm));
    UF_PrintM("%-20s %s\n", name, setup->gow_name); }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int VdRaiseShell()
{
  char name[IOBUFLEN];

  if (UF_ItemRead(name, IOBUFLEN, "raise shell name") && *name) {
    VdSetup setup;

    ForAllSetups(setup) {
      if (!strcmp(name, XtName(setup->shell))) {
	XRaiseWindow(XtDisplay(setup->shell), XtWindow(setup->shell));
	return TRUE; } }
    ErrPrint("error: shell '%s' not found\n", name);
    return FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
static int vdDelayed= FALSE;
/* ---------------------------------------------------------------------- */
int VdSuspend()
{
  if (!vdDelayed) { DN_Delay(TRUE); vdDelayed= TRUE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int VdResume()
{
  if (vdDelayed) { DN_Delay(FALSE); vdDelayed= FALSE; }
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int VdResumeForced()
{
  DN_ResumeForced();
  vdDelayed= FALSE;
  return TRUE;
}
/* ---------------------------------------------------------------------- */
int VdNormalizedDisplay()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    if (setup->dres) { return DR_DrawNormalized(setup); }
    else {
      Arg args[1];
      XtSetArg(args[0], XtNspectraNormalized, TRUE);
      XtSetValues(setup->gow, args, XtNumber(args));
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
int VdUnnormalizedDisplay()
{
  VdSetup setup;
  if ((setup= DW_GetSetup())) {
    if (setup->dres) { return DR_DrawUnnormalized(setup); }
    else {
      Arg args[1];
      XtSetArg(args[0], XtNspectraNormalized, FALSE);
      XtSetValues(setup->gow, args, XtNumber(args));
      return TRUE; } }
  return FALSE;
}
/* ---------------------------------------------------------------------- */
