/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdSpecList.c,v 1.3 1994/09/20 14:48:54 vs Exp vs $ */

#define _VdSpecList_c

#ifdef SOLARISBUG_X_INCLUDES
#undef NOSTDHDRS
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>

#include <tv/vsAlloc.h>
#include <tv/vsPath.h>

#include "VsSpectra.h"

#include "VdSpecList.h"
/* ---------------------------------------------------------------------- */
static String *list= NULL;
static String *dlist= NULL;
static Widget spectralist;
static int delaycount= 0;
static int listNum;
static Boolean changed= FALSE;
/* ---------------------------------------------------------------------- */
void DSL_Create(parent, num)
     Widget parent;
     int num;
{
  Widget vw;

  listNum= num;
  list= (String *)Malloc((num + 1) * sizeof(String));
  dlist= (String *)Malloc((num + 1) * sizeof(String));
  { int i; for (i= 0; i< num; i++) { list[i] = NULL; } }

  vw = XtVaCreateWidget("spectralist-view", viewportWidgetClass, parent,
			NULL);
  spectralist= XtVaCreateManagedWidget("spectralist", listWidgetClass,
				       vw,
				       XtNlist, list,
				       NULL);
  DSL_ChangedAll();
  XtManageChild(vw);
}
/* ---------------------------------------------------------------------- */
void DSL_Changed(idx)
     int idx;
{
  changed= TRUE;
  if (list) {
    if (idx >= 0){		/* DUKE: fehlte */
      Free(list[idx]);}
    if (idx >= 0 && VspcsFile(&vSpc,idx)) {
      char *p= PthShort(VspcsFile(&vSpc,idx));
      
      if ((list[idx]= (char *)Malloc((strlen(p)+6) * sizeof(char)))) {
	sprintf(list[idx], "%3d: %s", idx, p); } }

    { String *dl; int i; for (i= 0, dl= dlist; i< listNum; i++) {
      if (list[i]) { *dl++= list[i]; } }
      *dl= NULL; }

    if (!delaycount) {
      XawListChange(spectralist, dlist, 0, 0, TRUE);
      changed= FALSE; } }
}
/* ---------------------------------------------------------------------- */
void DSL_ChangedAll()
{
  changed= TRUE;
  if (list) {
    int i;
    for (i= 0; list[i]; i++) {
      Free(list[i]);
      if (VspcsFile(&vSpc,i)) {
	char *p= PthShort(VspcsFile(&vSpc,i));
      
	if ((list[i]= (char *)Malloc((strlen(p)+6) * sizeof(char)))) {
	  sprintf(list[i], "%3d: %s", i, p); } } }

    { String *dl= dlist; for (i= 0; i< listNum; i++) {
      if (list[i]) { *dl++= list[i]; } }
      *dl= NULL; }

    if (!delaycount) {
      XawListChange(spectralist, dlist, 0, 0, TRUE);
      changed= FALSE; } }
}
/* ---------------------------------------------------------------------- */
void DSL_Delay(delay_output)
     int delay_output;
{
  if (delay_output) { delaycount++; }
  else if (delaycount) {
    delaycount--;
    if (changed) {
      DSL_Changed(-1); } }
}
/* ---------------------------------------------------------------------- */
void DSL_ResumeForced()
{
  delaycount= 0;
  if (changed) { DSL_Changed(-1); }
}
/* ---------------------------------------------------------------------- */
