/* $Header: /usr/files/home/Gamma/vs/tv/edit/clients/tv/RCS/VdWidget.h,v 1.3 1994/09/20 14:49:00 vs Exp vs $ */
#ifndef _VdWidget_h
#define _VdWidget_h

#include <Gow/GowConfig.h>
#include <Gow/DrawAxis.h>

#include "VsActiv.h"

typedef struct _VdSetupRec {
  int num;			/* number */
  Widget shell;			/* for io redirection */
  struct _VdStatusRec *status;	/* status */
  String gow_name;		/* for identification purposes */
  Widget gow;
  Widget frm;
  Cursor cursor;
  DrawAxisRec axis[AXIS_NUM];
  struct _GowVMarkRec *dbin;
  struct _VdCutRec *dcut;
  struct _GowLabelRec *dcutlbl;
  struct _GowDecompRec *ddecomp;
  struct _VdFitRec *dfit;
  struct _GowLabelRec *dfitlbl;
  struct _VdLabelRec *dlbl;
  struct _VdMarkRec *dmrk;
  struct _GowLabelRec *dpeaklbl;
  struct _GowPeakListRec *dpeaks;
  struct _VdLabelRec *dpos;
  struct _VdSetupRec *dpro;
  struct _GowResidRec *dres;
  struct _GowSpcRec *dspc;
  Vact_t act;
  struct _VdSetupRec *next;
} VdSetupRec, *VdSetup;

#define ForAllSetups(setup) for (setup= vdSetupRoot; setup; setup= setup->next)

#ifdef _VdWidget_c
VdSetup vdSetupRoot= NULL;
#else
extern VdSetup vdSetupRoot;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VdWidgetF.h"

#undef P_

#endif				/* _VdWidget_h */

