/* VdWidget.c */
static int CreateSimpleShell P_((char *name));
static int CreatePaned P_((char *name, int num, int x_link, int y_link));
static VdSetup CreateGowSetup P_((VdStatus status, Widget shell, char *name, char *title, GowScale x_scale, GowScale y_scale, int inheritable_scale, Vact_t a));
static void InitSpectraGow P_((VdSetup vds));
static void InitResidGow P_((VdSetup vds));
static void InitCutGow P_((VdSetup vdsc, VdSetup vdsp));
static int InputMode P_((int new_focus, Widget widget));
static void EditFocusLockAction P_((Widget w, XEvent *event, String *params, Cardinal *num_params));
static void EditFocusUnlockAction P_((Widget w, XEvent *event, String *params, Cardinal *num_params));
static void DestroyActCallback P_((Widget w, XtPointer p, XtPointer unused_too));
static void DestroyScaleCallback P_((Widget w, XtPointer p, XtPointer unused_too));
static void DestroySetupCallback P_((Widget w, XtPointer p, XtPointer unused_too));
static void LockWidget P_((VdSetup setup));
static void UnlockWidget P_((void));
static void LockWidgetAction P_((Widget w, XEvent *event, String *params, Cardinal *num_params));
static void UnlockWidgetAction P_((Widget w, XEvent *event, String *params, Cardinal *num_params));
static void SetCurrentWidget P_((Widget w, XtPointer unused, XEvent *event, Boolean *unused_too));
