/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsActiv.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */
#ifndef _VsActiv_h
#define _VsActiv_h

#include <tv/vsTypes.h>

#define ACT_SDEFAULT		1
#define ACT_SUNCALIB		2
#define ACT_SCALIBRATED		3

#define ACT_EDEFAULT		1
#define ACT_EAUTO		2
#define ACT_EREQUEST		3

typedef struct {
  int scale;
  int spcIdx;
  int prevSpcIdx;
  int cutIdx;
  int prevCutIdx;
  int expand;
  int names;
  char *title;
  IVecRec managed;
} VactRec, *Vact_t;

#define VactScale(ap)		((ap)->scale)
#define VactSpcIdx(ap)		((ap)->spcIdx)
#define VactPrevSpcIdx(ap)	((ap)->prevSpcIdx)
#define VactCutIdx(ap)		((ap)->cutIdx)
#define VactPrevCutIdx(ap)	((ap)->prevCutIdx)
#define VactExpand(ap)		((ap)->expand)
#define VactNames(ap)		((ap)->names)
#define VactTitle(ap)		((ap)->title)

#define VactManagedVec(ap)	(&(ap)->managed)
#define VactManagedP(ap)	VecP(VactManagedVec(ap))
#define VactNum(ap)		VecNum(VactManagedVec(ap))

#define VactManaged(ap,i)	(VactManagedP(ap)[i])

#define VactCalibrated(s)	((s != ACT_SDEFAULT) ? (s == ACT_SCALIBRATED) \
				 : (VactScale(vActDefault) == ACT_SCALIBRATED))
#define VactScaleText(s) (VactCalibrated(s) ? "calibrated" : "uncalibrated")

#define VactExpandAutomatic(s)	((s != ACT_EDEFAULT) ? (s == ACT_EAUTO) \
				 : (VactExpand(vActDefault) == ACT_EAUTO))
#define VactExpandText(s) (VactExpandAutomatic(s) ? "automatic" : "on request")
#ifdef _VsActiv_c
Vact_t vAct= NULL;
Vact_t vActDefault= NULL;
#else
extern Vact_t vAct;
extern Vact_t vActDefault;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsActivF.h"

#undef P_

#endif				/* _VsActiv_h */

