/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsCal.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    VsCal.h
 */
#ifndef _VsCal_h
#define _VsCal_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsCal.h>

typedef struct {
  SerialId_t serialId;
  CalRec cal;
} Vcal_t;

#define VcalCal(p)		(&((p)->cal))
#define VcalSerialId(p)		((p)->serialId)

typedef struct {
  int num;			/* number */
  int typ;			/* operate on typ */
  char *name;			/* name of typ to operate on */
  Vcal_t *p;			/* calibration vector */
} Vcals_t;

#define VcalsNum(cp)		((cp)->num)
#define VcalsTyp(cp)		((cp)->typ)
#define VcalsName(cp)		((cp)->name)
#define VcalsP(cp)		((cp)->p)
#define VcalsCal(cp,i)		VcalCal(VcalsP(cp)+(i))
#define VcalsSerialId(cp,i)	VcalSerialId(VcalsP(cp)+(i))

#ifdef _VsCal_c
Vcals_t vCal;
#else
extern Vcals_t vCal;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsCalF.h"

#undef P_

#endif				/* _VsCal_h */
/* ------------------------------------------------------------------------- */
