/* VsCut.c */
static void Cut_Changed P_((int idx));
static int Cut_InitBuffer P_((int num));
static int Cut_InitVcut P_((Vcut_t *cp));
static int Cut_ResetVcut P_((int cutIdx));
static int Cut_ResetGates P_((int cutIdx));
static int Cut_ResetSpectrum P_((int cutIdx));
static int Cut_InitVcutPath P_((VcutPath_t *pp));
static int Cut_InitVmtx P_((Vmtx_t *mp));
static int Cut_CreateHeadP P_((int cutIdx));
static int Cut_CreateFac P_((int cutIdx));
static int Cut_CreateFacFit P_((int cutIdx));
static int Cut_IntegratePeak P_((Cut_t cp, int proIdx, int peaIdx, double *tmpInt, int *idx, double *vol));
static int Cut_IntegrateSearch P_((Cut_t cp, int proIdx, SeaPeak seaPeak, double *tmpInt, int *idx, double *vol));
static void Cut_IntegrateBg P_((Cut_t cp, int proIdx, double *bgInt));
static int Cut_CreateFacGate P_((int cutIdx));
static int Cut_CreateSpectrumP P_((int cutIdx));
static int Cut_CutPathCloseP P_((int pathIdx));
static int Cut_CutPathOpenP P_((int pathIdx, char *path, char *cutFmt));
static int Cut_MtxCloseP P_((int mtxIdx));
static int Cut_MtxOpenP P_((int mtxIdx, char *path, char *mtxFmt));
static char *Cut_Substitute P_((char *path, char *pattern));
static int Cut_EntryIdx P_((int *cDirIdx, int cutPathIdx, int incTyp));
static int Cut_EntryName P_((Vcut_t *cp, int *cDirIdx));
static int Cut_EntryPos P_((Vcut_t *cp, int *cDirIdx));
static int Cut_ListP P_((int cpIdx, Cal_t cal, double chn1, double chn2));
static int Cut_CpMrkToGat P_((GVec_t gt, PVec_t mrk));
static int Cut_MrkGet P_((int idx));
static int Cut_MrkPut P_((Vcut_t *vcp));
static int Cut_MrkAndNot P_((PVec_t aMrk, char *aName, PVec_t bMrk, char *bName));
static int Cut_CheckCutPath P_((int cpIdx));
static int Cut_ReadHead P_((int cDirIdx, int idx));
static int Cut_EntryLabel P_((Vcut_t *cp, int *idx));
static int Cut_Rename P_((Vcut_t *vcp));
static int Cut_Rm P_((Vcut_t *cp, int cDirIdx, char *expr));
static int Cut_ShowCutP P_((int cutIdx));
static int Cut_ShowCutPathP P_((int cutPathIdx));
static int Cut_ShowMtxP P_((int mtxIdx));
static int Cut_WriteHeadP P_((int cutIdx));
