/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsRecal.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    VsRecal.h
 */
#ifndef _VsRecal_h
#define _VsRecal_h

#include <tv/vsTypes.h>
#include <tv/vsRecal.h>

typedef struct {
  RclRec rcl;
  char spcFile[MAXPATHLEN];
} Vrcl_t;

#define VrclRcl(p)		(&((p)->rcl))
#define VrclSpcFile(p)		((p)->spcFile)

typedef struct {
  int num;			/* number */
  int typ;			/* operate on typ */
  PVecRec mrk;			/* recalibration marker */
  char *name;			/* name of recalibration type */
  Vrcl_t *p;			/* calibration vector */
} Vrcls_t;

#define VrclsNum(rp)		((rp)->num)
#define VrclsTyp(rp)		((rp)->typ)
#define VrclsMrk(rp)		(&(rp)->mrk)
#define VrclsName(rp)		((rp)->name)
#define VrclsP(rp)		((rp)->p)
#define VrclsRcl(rp,i)		VrclRcl(VrclsP(rp)+(i))
#define VrclsSpcFile(rp,i)	VrclSpcFile(VrclsP(rp)+(i))

#ifdef _VsRecal_c
Vrcls_t vRcl;
#else
extern Vrcls_t vRcl;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsRecalF.h"

#undef P_

#endif				/* _VsRecal_h */
/* ------------------------------------------------------------------------- */
