/* $Header: /usr/files/home/Gamma/vs/tv/edit/prg/RCS/VsSearch.h,v 1.1 1993/09/17 14:53:34 vs Exp vs $ */ 
/* -------------------------------------------------------------------------
 *                    VsSearch.h
 */
#ifndef _VsSearch_h
#define _VsSearch_h

#include <tv/SerialId.h>
#include <tv/vsTypes.h>
#include <tv/vsSearch.h>

typedef struct {
  SerialId_t spcSerialId;
  SeaPeakList sea;
} Vsea_t;

#define VseaSpcSerialId(p)	((p)->spcSerialId)
#define VseaSea(p)		((p)->sea)

typedef struct {
  int num;
  Vsea_t *s;
  double prob;
  PVecRec mrk;
} Vseas_t;

#define VseasNum(p)		((p)->num)
#define VseasS(p)		((p)->s)
#define VseasProb(p)		((p)->prob)
#define VseasMrk(p)		(&((p)->mrk))

#define VseasSpcSerialId(p,i)	VseaSpcSerialId(VseasS(p)+i)
#define VseasSea(p,i)		VseaSea(VseasS(p)+i)


#ifdef _VsSearch_c
Vseas_t vSea;
#else
extern Vseas_t vSea;
#endif

#if !defined(NOPROTO) && (defined(__STDC__) || defined(VSPROTO) || defined(__cplusplus))
# define P_(s) s
#else
# define P_(s) ()
#endif

#include "VsSearchF.h"

#undef P_

#endif				/* _VsSearch_h */
/* ------------------------------------------------------------------------- */
